#!/usr/bin/perl

################################################################################
#     Beomdori's Board v1.6+
#
#     Programmer : BeomGyu, Lee
#     E-Mail     : cadeau@orgio.net
#     Homepage   : http://beomdori.x-y.net
#
################################################################################

require "./lib/cm_get_supervisor_config.cgi";
&get_supervisor_config;
################################################################################
 
umask(000);
&parseArgument;

sub parseArgument {
    require "./lib/cm_parse1.cgi";
    require "./lib/cm_parse2.cgi";
    require "./lib/cm_alert.cgi";
        	
    local (%FORM); 
     
    if($ENV{'CONTENT_TYPE'} =~ m/^multipart\/form-data/) {
     	&parse1;
    }
    else {
        &parse2;
    }
    
    if($FORM{'db'}) {
        $gBaseDIR = "./db/$FORM{'db'}";
        $gNumFile = "$FORM{'db'}_num.cgi";
        $gCfgFile = "$FORM{'db'}_cfg.cgi";
        $gPwdFile = "$FORM{'db'}_pwd.cgi";
        $gDatFile = "$FORM{'db'}_dat.cgi";
        $gNtcFile = "$FORM{'db'}_ntc.cgi";        
    }
    else {
           $msg = "ũϴ  : \"http\:\/\/\~\/bdr_board.cgi?db=DB\"Դϴ.     "; 
           alert($msg);
    }
    
    if(open(HANDLE,"<$gBaseDIR/$gNumFile")) {
        close(HANDLE);

        require "./lib/cm_check_bdr_cgi.cgi";
	&check_bdr_cgi("bdr_board");
        &selectAction;
    }
    else {
        require "./lib/cm_get_cookie.cgi";    	
        &get_cookie;
        
        require "./lib/cm_check_password.cgi";
        if(&check_supervisor_password("$COOKIE{'ROOTADMIN'}") eq "true") {
           &selectAction;
        }
        else {
           $msg = "ڸ DB   ֽϴ."; 
           alert($msg);
        }
    }
}

# Խ  - ɿ  ˸  ̵
sub selectAction {
    require "./lib/cm_check_member.cgi";
    require "./lib/cm_check_password.cgi";
    require "./lib/cm_get_cookie.cgi";
    require "./lib/cm_get_num_info.cgi";
    require "./lib/cm_html_head.cgi";
            
    &get_num_info;
    &get_config_variables;
    &get_cookie;

    unless($FORM{'action'}) {
        $FORM{'action'} = "r";
    }
    
    if($gUserType eq "type_member") {
       &check_member if(&check_supervisor_password("$COOKIE{'ROOTADMIN'}") eq "false");
    }
    
    if($FORM{'action'} eq "r") {	
       &read_data;
    }     
    elsif($FORM{'action'} eq "show_config_form") {       	
            &check_admin_password;
            &show_config_form;
    }      
    elsif($FORM{'action'} eq "config") {
            &update_config_variables;
    }
    elsif($FORM{'action'} eq "insert_emoticon") {
    	 require "./lib/bd_emoticon_viewer.cgi";
            &emoticon_viewer;
    }            
    elsif($FORM{'action'} eq "login") {
            &check_member;
    }
    elsif($FORM{'action'} eq "search") {
            &get_num_info;  
            &html_head("bdr_board");
            &show_top_menu;              	                               
            &search_data;
    }
    elsif($FORM{'action'} eq "show_user_input_form") {
    	 if($gAdminOnly eq "checked") {     # ڸ   
    	    &check_admin_password;
    	 }
        	 else {
        	    &check_member if(($gUserType eq "type_member") || ($gUserType eq "type_only_read"));
        	 }
            &show_user_input_form;
    }
    elsif($FORM{'action'} eq "show_admin_input_form") {       	
            &check_admin_password;
            &show_user_input_form;
    }               
    elsif($FORM{'action'} eq "write") {
            &check_member if(($gUserType eq "type_member") || ($gUserType eq "type_only_read"));                 
            &write_data;
    }         
    elsif($FORM{'action'} eq "download") {
            &check_member if(($gUserType eq "type_member") || ($gUserType eq "type_only_read"));         	         	
            &download_data;
    }                
    elsif($FORM{'action'} eq "delete") {
            &check_member if(($gUserType eq "type_member") || ($gUserType eq "type_only_read"));
            &check_user_password;
            &delete_data;
    } 
    elsif($FORM{'action'} eq "show_content") {
             &check_member if(($gUserType eq "type_member") || ($gUserType eq "type_only_read"));
             unless($FORM{'mode'} eq "memo") {
               &add_hit_counter;
             }
             &read_data;
    } 
    elsif($FORM{'action'} eq "show_only_content") {           # Ʈ 븸 ⸦ 
             &check_member if(($gUserType eq "type_member") || ($gUserType eq "type_only_read"));
             unless($FORM{'mode'} eq "memo") {
               &add_hit_counter;
             }
             &read_data;
    } 
    elsif($FORM{'action'} eq "memo_data") {
            &MemoData;
    }           
    elsif($FORM{'action'} eq "show_update_form") {
            &check_member if(($gUserType eq "type_member") || ($gUserType eq "type_only_read"));
            &check_user_password;
            &show_update_form;
    } 
    elsif($FORM{'action'} eq "update") {
            &update_data;
    } 
    elsif($FORM{'action'} eq "users_login") {
            &show_user_ogin;
    }
    elsif($FORM{'action'} eq "show_notice_form") {               #  
    	 &check_admin_password;
            &show_notice_input_form;
    }
    elsif($FORM{'action'} eq "write_notice") {	
            &write_notice_data;
    }
    elsif($FORM{'action'} eq "show_notice_content") {
            &read_notice_data;
    }
    elsif($FORM{'action'} eq "delete_notice") {
            &check_admin_password;
            &delete_notice_data;
    }
    elsif($FORM{'action'} eq "show_notice_update_form") {
            &show_notice_update_form;
    }        
    elsif($FORM{'action'} eq "update_notice") {
            &update_notice_data;
    }         
    elsif($FORM{'action'} eq "img_view") {
    	 require "./lib/bd_img_viewer.cgi";
    	 &img_viewer;
    }
    elsif($FORM{'action'} eq "admin_login") {        #  ȯ漳 ޴
       if((&check_supervisor_password("$COOKIE{'ROOTADMIN'}") eq "true") 
            && (($FORM{'c'} ne "show_notice_form")) 
            && (($FORM{'c'} ne "delete_notice")) 
            && (($FORM{'c'} ne "show_notice_update_form"))) {
            &show_config_form;
       }
       else {
            &show_admin_login;
       }           	
    }
    else {
          exit;
    }
}
	


##########################################################################
# bdr_board ȯ漳 оδ.
##########################################################################
sub get_config_variables {
    local($env_list);
    local(@datum);

    if(open(HANDLE,"<$gBaseDIR/$gCfgFile")) {
        $env_list = <HANDLE>;
        close(HANDLE);
        @datum = split(/\|/,$env_list);

        $gCgiType = $datum[12];       # cgi  ϱ  -  board 
        $gBackColor = $datum[1];
        $gBackImgURL = $datum[2];
        
        $gUserType = $datum[20];      # Ÿ : Ϲ type_normal, ȸ type_member, ⸸ type_only_read
        $gAdminOnly = $datum[35];
                        
        $gRecPerPage = $datum[6];
        $gListNumber = $datum[7];

        $gTableWidth = $datum[5];
        $gTableBgColor = $datum[21];
        $gTableTextColor = $datum[15];
        $gActiveTableColor = $datum[14];
        $gTextColor = $datum[17];
        $gTitleUse = $datum[11];        
        $gAlignType = $datum[26];              # Display Ĺ 
        $gFList = $datum[3];                   # Ϻ̱
        $gFileLink = $datum[28];               # ϸũ
        $gFileImgLink = $datum[36];            # ̹ũ        
        $gFileUpload = $datum[29];             # Ͼε
        $gFileImgUpload = $datum[4];           # ũε        
        $gMaxFileSize = $datum[30];            # Ͼε ִũ
        $gTableTitleBgColor = $datum[31];
        $gTableTitleTextColor = $datum[32];
        $gMinmumHit = $datum[33];              
        $gWriteMemo = $datum[13];              # ޸̱
        $gShowEmoticon = $datum[34];
        $gUsePreview = $datum[16];		
        $gPreviewWidth = $datum[8];
        $gPreviewLength = $datum[10];                        
        $gPreviewBgcolor = $datum[9];
        $gPreviewTextcolor = $datum[18];        
        $gShowIPInfo = $datum[25];     

        $gMyTemp01 = $datum[37];
        $gMyTemp02 = $datum[38];
        $gMyTemp03 = $datum[39];
        $gMyTemp04 = $datum[40];
        $gMyTemp05 = $datum[41];
        $gMyTemp06 = $datum[42];
        $gMyTemp07 = $datum[43];
        $gMyTemp08 = $datum[44];
        $gMyTemp09 = $datum[45];
        $gMyTemp10 = $datum[46];
        $gMyTemp11 = $datum[47];        
        $gTempColor5 = $datum[22];
        $gTempColor6 = $datum[23];
        $gTempColor8 = $datum[27];                        
        $gTempYesOrNo1 = $datum[19];        
        $gTempYesOrNo2 = $datum[24];  
                
        #chop($gHomeImageURL);
    }
    else {
        # ʱ ȯ 
        $gCgiType = "board";
        $gBackColor = "#ffffff";
        $gBackImgURL = "./img/board/bg.gif";
        $gUserType = "type_normal";                  # Ÿ : Ϲ type_normal, ȸ type_member, б⸸ type_only_read
        $gAdminOnly = "";                                     
        $gTableWidth = "95%";
        $gTableBgColor = "#ffffff";
        $gTableTextColor = "#000000";
        $gActiveTableColor = "#f5f5f5";
        $gTextColor = "#000000";
        $gTitleUse = "checked";           
        $gRecPerPage = "10";
        $gListNumber = "5";
        $gAlignType = "center";
        $gFList = "checked"; 
        $gFileImgLink = "checked";
        $gFileLink = "";
        $gFileUpload = "";
        $gFileImgUpload = "";        
        $gMaxFileSize = "1";                          # 1MB
        $gTableTitleBgColor = "#2d6096";
        $gTableTitleTextColor = "#000000";
        $gMinmumHit = "50";                
        $gWriteMemo = "checked";                
        $gShowEmoticon = "checked";
        $gUsePreview = "checked";                
        $gPreviewWidth = "300";
        $gPreviewBgcolor = "#eeeeee";        
        $gPreviewTextcolor = "#000000";        
        $gPreviewLength = "250";
        $gShowIPInfo = "checked";

        $gMyTemp01 = "";
        $gMyTemp02 = "";
        $gMyTemp03 = "";
        $gMyTemp04 = "";
        $gMyTemp05 = "";
        $gMyTemp06 = "";
        $gMyTemp07 = "";
        $gMyTemp08 = "";
        $gMyTemp09 = "";
        $gMyTemp10 = "";
        $gMyTemp11 = "";                                
        $gTempColor5 = "";
        $gTempColor6 = "";
        $gTempColor8 = "";                        
        $gTempYesOrNo1 = "";
        $gTempYesOrNo2 = "";

        &put_config_variables;
    }
}

##########################################################################
# bdr_board ȯ漳 ȭϿ Ѵ.
########################################################################## 
sub put_config_variables {
    require "./lib/cm_lock.cgi";	
    
    &lock("$FORM{'db'}_cfg");
    open(HANDLE,">$gBaseDIR/$gCfgFile");
        print HANDLE "|$gBackColor|$gBackImgURL|$gFList|$gFileImgUpload|$gTableWidth|$gRecPerPage|$gListNumber|$gPreviewWidth|$gPreviewBgcolor|$gPreviewLength|$gTitleUse|$gCgiType|$gWriteMemo|$gActiveTableColor|$gTableTextColor|$gUsePreview|$gTextColor|$gPreviewTextcolor|$gTempYesOrNo1|$gUserType|$gTableBgColor|$gTempColor5|$gTempColor6|$gTempYesOrNo2|$gShowIPInfo|$gAlignType|$gTempColor8|$gFileLink|$gFileUpload|$gMaxFileSize|$gTableTitleBgColor|$gTableTitleTextColor|$gMinmumHit|$gShowEmoticon|$gAdminOnly|$gFileImgLink|$gMyTemp01|$gMyTemp02|$gMyTemp03|$gMyTemp04|$gMyTemp05|$gMyTemp06|$gMyTemp07|$gMyTemp08|$gMyTemp09|$gMyTemp10|$gMyTemp11|\n";
    close(HANDLE);
    &unlock("$FORM{'db'}_cfg");
}

##########################################################################
# Ÿ оδ.
##########################################################################
sub read_data {
    require "./lib/cm_html_head.cgi";
	
    if($FORM{'p'}) {
        $gCurPage = $FORM{'p'};
    }
    else {
        $gCurPage = "1";
    }

    $gTotPage = int(($gNoOfData-1)/$gRecPerPage)+1;

    &html_head("bdr_board");
   
    if($FORM{'action'} eq "show_content") {      # 뺸   	    	
       &read_file_content;

       if($gFList eq "checked") {                   # Ʈ ½
          if($FORM{'keyword'}) {                    # ˻ ´ܾ 
             &show_top_menu;       	
             &search_data;
          }         
          else {
             &show_top_menu;       
             &read_notice_index_file;
             &read_index_file;
          }
       }       
       &show_bottom_menu;   
       &show_search_form;    
    }
    elsif($FORM{'action'} eq "show_only_content") {                         # bdr_list â 뺸
       &read_file_content;
    }
    else {                                                           # Ϻ
       &show_top_menu;    	
       &read_notice_index_file;
       &read_index_file;
       &show_bottom_menu;   
       &show_search_form;    
     }
    
    &html_foot;
}

##########################################################################
#  Ÿ оδ.
##########################################################################
sub read_notice_data {
    require "./lib/cm_html_head.cgi";

    if($FORM{'p'}) {
        $gCurPage = $FORM{'p'};
    }
    else {
        $gCurPage = "1";
    }

    $gTotPage = int(($gNoOfData-1)/$gRecPerPage)+1;
    	
    &html_head("bdr_board");
   
    if($FORM{'action'} eq "show_notice_content") {      # 뺸
       &read_notice_file_content;

       if($gFList eq "checked") {                   # Ʈ ½
          &show_top_menu;       
          &read_notice_index_file;
          &read_index_file;
       }     
       &show_bottom_menu;   
       &show_search_form;    
    }
    elsif($FORM{'action'} eq "show_only_content") {                  # bdr_list â 뺸
       &read_notice_file_content;
    }
    else {                                                           # Ϻ
       &show_top_menu;    	
       &read_notice_index_file;
       &read_index_file;
       &show_bottom_menu;   
       &show_search_form;    
    }
    
    &html_foot;
}

##########################################################################
# ָ޴ 
##########################################################################
sub show_top_menu {	
    if(!-e "./members/logon/$COOKIE{'MEMBER_ID'}.cgi") {
       $gIsMember = false;	
    }
    else {
       $gIsMember = true;	
    }

    opendir(DIR, "./members/logon");
      @login_user = readdir(DIR);
    closedir(DIR);   
    $visiter_num = $#login_user - 1;
           
    print "<table border=0 width=$gTableWidth cellspacing=0 cellpadding=0 align=center>\n";

    if(($FORM{'action'} eq "search") || ($FORM{'keyword'})) {
       print "<tr><td align=left>&nbsp;</td>\n";
    }
    else {
       print "<tr><td align=left><font face=\"tahoma, arial\" size=1>Loged Members : <a href=javascript:NewWin('200','200','380','450','ShowMemberWin','bdr_member.cgi?action=show_logined_member')>$visiter_num</a><br><img src=$gIMG_Board/total.gif border=0><font color=red>$gNoOfData</font><img src=$gIMG_Board/articles.gif border=0><font color=#ff0000>$gCurPage</font>/$gTotPage<img src=$gIMG_Board/page.gif border=0></font></td>\n";
    } 
    if($gIsMember eq "true") {
       print "<td align=right valign=bottom><a href=javascript:NewWin('200','200','510','580','ModifyWin','bdr_member.cgi?action=modify_form')><IMG SRC=$gIMG_Board/Info.gif border=0></a> <a href=bdr_login.cgi?db=$FORM{'db'}&action=logout_data2><IMG SRC=$gIMG_Board/logout.gif border=0></a></td></tr>\n";
    }
    else {
      print "<td align=right valign=bottom><a href=javascript:NewWin('200','200','510','580','RegisterWin','bdr_member.cgi')><IMG SRC=$gIMG_Board/register.gif border=0></a> <a href=bdr_board.cgi?db=$FORM{'db'}&action=login><IMG SRC=$gIMG_Board/login.gif border=0></a></td></tr>\n";    
    }
    print "</td></tr></table>\n";
    
    print "<table border=1 width=$gTableWidth bgcolor=$gTableTitleBgColor bordercolorlight=$gTableTitleBgColor bordercolordark=#cccccc cellspacing=0 cellpadding=0 align=center>\n";
    if(($gFileUpload eq "checked") || ($gFileLink eq "checked")) {      # ڷ
       print "<tr>\n";
       print "<td nowrap align=center valign=middle width=30 height=21><img src=$gIMG_Board/no.gif border=0></td>\n";
       print "<td nowrap align=center valign=middle style='width:100%;word-break:break-all;'><img src=$gIMG_Board/subject.gif border=0></td>\n";
       print "<td nowrap align=center valign=middle width=90><img src=$gIMG_Board/name.gif border=0></td>\n";           
       print "<td nowrap align=center valign=middle width=90><img src=$gIMG_Board/date.gif border=0></td>\n";
       print "<td nowrap align=right valign=middle width=40><img src=$gIMG_Board/down.gif border=0></td>\n";  
       print "<td nowrap align=right valign=middle width=40><img src=$gIMG_Board/read.gif border=0></td>\n";       
    }
    else {                                                     # Խ
    
       print "<tr>\n";
       print "<td nowrap align=center valign=middle width=30 height=21><font color=$gTableTitleTextColor><img src=$gIMG_Board/no.gif border=0></font></td>\n";
       print "<td nowrap align=center valign=middle style='width:100%;word-break:break-all;'><font color=$gTableTitleTextColor><img src=$gIMG_Board/subject.gif border=0></font></td>\n";
       print "<td nowrap align=center valign=middle width=90><font color=$gTableTitleTextColor><img src=$gIMG_Board/name.gif border=0></font></td>\n";
       print "<td nowrap align=center valign=middle width=90><font color=$gTableTitleTextColor><img src=$gIMG_Board/date.gif border=0></font></td>\n";                
       print "<td nowrap align=right valign=middle width=40><font color=$gTableTitleTextColor><img src=$gIMG_Board/read.gif border=0></font></td>\n";
    }
    print "</tr>\n</table>\n";    
}

##########################################################################
# ޴
##########################################################################
sub show_bottom_menu {
    print "<table border=0 width=$gTableWidth border=0 cellspacing=1 cellpadding=2 align=$gAlignType>\n";
    print "<tr>\n";
    print "<td align=left align=top width=30%>\n";
    print "<a href=bdr_board.cgi?db=$FORM{'db'}&action=admin_login&c=show_config_form&p=$gCurPage><img src=$gIMG_Board/admin.gif border=0 alt=\" \"></a> \n";
    
    if($gAdminOnly eq "checked"){     # ڸ   
       print "<a href=bdr_board.cgi?db=$FORM{'db'}&action=admin_login&c=show_user_input_form>\n";
    }
    else {
       print "<a href=bdr_board.cgi?db=$FORM{'db'}&action=show_user_input_form>";
    }         	     
    
    print "<img src=$gIMG_Board/write.gif border=0 alt=\"\"></a></td>\n";
    print "<td align=center width=40%>\n";
    &go_prev_next_page;	    
    print "</td>\n";
    print "<td align=right align=top width=30%>\n";
    
    $term = 1;
    $f = 1;
    $l = $term;
    
    while ($f <= $gTotPage) {
      if(($f <= $gCurPage) && ($gCurPage <= $l)) {
         $prevp = $f - 1;
        if ($prevp > 0) {
          print "<a href=bdr_board.cgi?db=$FORM{'db'}&action=r&p=$prevp><img src=$gIMG_Board/previous.gif border=0 alt=\" \"></a> ";
        }
        else {
          print "<img src=$gIMG_Board/previous_n.gif border=0 alt=\"ù \"> ";
        }
        
       $nextp = $l + 1;
       if($nextp <= $gTotPage) {
         print "<a href=bdr_board.cgi?db=$FORM{'db'}&action=r&p=$nextp><img src=$gIMG_Board/next.gif border=0 alt=\" \"></a>";
       }
       else {
         print "<img src=$gIMG_Board/next_n.gif border=0 alt=\" \">";
       }
     }
     $f = $f + $term;
     $l = $l + $term;
   }

    print "</td></tr>\n";
    print "</table>\n";
}

##########################################################################
# ȭ鿡 Խ  Ʈ 
##########################################################################
sub read_index_file {
    require "./lib/cm_get_date.cgi";
    	
    local($i,$j,$cnt_memo,$blank,$temp_img,$temp_color,$actual_number,$short_date);
    local(@datum,@data_fn,@value_fn,@value);

    &get_date;
        
    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);
   
    print "<table border=0 width=$gTableWidth cellspacing=0 cellpadding=0 valign=top align=center>\n";
    print "<tr><td>\n";
      
    for($i=($gCurPage-1)*$gRecPerPage+1;$i<=($gCurPage-1)*$gRecPerPage+$gRecPerPage;$i++) {
        @data_fn = split(/\|/,$datum[$i]);       
        if(-e "$gBaseDIR/data/$data_fn[1].cgi") {
            open(HANDLE, "<$gBaseDIR/data/$data_fn[1].cgi");
              @value_fn = <HANDLE>;
            close(HANDLE);              	
         }
             
        @value = split(/\|/, $value_fn[0]);               
        
        &printRecord;      # Խù 
    }
    print "</td></tr></table>\n";
   
   unless($gNoOfData) {
        print "&nbsp;<table width=$gTableWidth border=0 cellspacing=1 cellpadding=6 align=center>\n";
        print "<tr align=center><td><font color=\"red\"><b> ϵ  ϴ.</font></b></td></tr></table>\n";
    }
}

##########################################################################
# ȭ鿡  Ʈ 
##########################################################################
sub read_notice_index_file {
    require "./lib/cm_get_date.cgi";
    	
    local($k,$i,$gNoOfNtc,$gCols_Cnt,$short_date,$date_length,$actual_number);
    local(@datum,@data_fn,@value_fn,@value);
    
    &get_date;
    
    open(HANDLE,"$gBaseDIR/$gNtcFile");
      @datum = <HANDLE>;
    close(HANDLE);
    foreach(@datum) {
       $gNoOfNtc++;
    }
                          
    print "<table border=0 width=$gTableWidth cellspacing=0 cellpadding=0 valign=top align=center>\n";
    print "<tr><td>\n";

    for($k=1; $k<$gNoOfNtc; $k++) {
    	$i=($gCurPage-1)*$gRecPerPage+1;
    	
        @data_fn = split(/\|/,$datum[$k]);
        if(-e "$gBaseDIR/data/$data_fn[1].cgi") {
            open(HANDLE, "<$gBaseDIR/data/$data_fn[1].cgi");
              @value_fn = <HANDLE>;
            close(HANDLE);              	
         }

        @value = split(/\|/, $value_fn[0]);               

        $actual_number = $gNoOfNtc-$k;
         
        if($actual_number > 0) {
             $date_length = length($date);
             $short_date = substr($value[5],0,20);             
             
             print "<table border=0 bgcolor=$gActiveTableColor cellpadding=0 cellspacing=0 width=100%>\n";
             print "<tr onMouseOver=this.style.backgroundColor=\"$gBackColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
             print "<td nowrap align=center valign=middle width=30><font color=$gTableTextColor size=1>notice</font></td>\n"; #ȣ ġ

             # 
             print "<td nowrap align=left valign=middle style='width:100%;word-break:break-all;'>&nbsp;<img src=\"$gIMG_Board/notice.gif\" border=0 height=16>&nbsp;";
             if($gUsePreview eq "checked") {  # ̸ 
                $tmp_content = substr($value[6],0,$gPreviewLength);            	  
                $tmp_content =~ s/</&lt;/g;             	
                $tmp_content =~ s/>/&gt;/g;
                $tmp_content =~ s/&lt;br&gt;/<br>/g;
                $tmp_content =~ s/&lt;p&gt;/<p>/g;                  
                $tmp_content =~ s/"/&quot;/g;
                $tmp_content =~ s/\'/&quot;/g;
                $tmp_content =~ s/-//g;
                $tmp_content =~ s/\|/&#124;/g;                
                $tmp_content =~ s/\r\n\r\n/<p>/g;
                $tmp_content =~ s/\r\n/<br>/g;
              
                print "<div id=my_preview_notice$actual_number class=hide_preview><table bgcolor=$gPreviewBgcolor border=0 cellpadding=0 cellspacing=0 width=$gPreviewWidth><tr><td class=cont><font color=$gPreviewTextcolor>$tmp_content...</font></td></tr></table></div>\n";
                print "<span id=OverDiv_notice$actual_number style=\"visibility:visible;cursor:hand\" onMouseOut=\"hide_content('my_preview_notice$actual_number');\">\n";
                print " <b><a href=\"bdr_board.cgi?db=$FORM{'db'}&action=show_notice_content&ntc=$k&n=$i&p=$gCurPage\" onMouseMove=\"show_content('my_preview_notice$actual_number', '', event, 'cmt');\"><font color=$gTableTextColor>$value[9]</font></a></b> \n"; # 
                print "</span>\n";
             }
             else {
                print "<b><a href=bdr_board.cgi?db=$FORM{'db'}&action=show_notice_content&ntc=$k&n=$i&p=$gCurPage><font color=$gTableTextColor>$value[9]</font></a></b>";
             }
            
             if($value[5] eq $date) {                #   
                print "<img src=$gIMG_Board/new.gif border=0>";
             }
             print "</td>\n";

             print "<td nowrap align=center valign=middle width=90><font color=$gTableTextColor>$value[2]</font>";   # ̸             
             if($value[4] ne "") {
                print "<a href=\"javascript:NewWin('200','200','300','309','MailWin','bdr_mail.cgi?fromname=$COOKIE{'MEMBER_NAME'}&frommail=$COOKIE{'MEMBER_EMAIL'}&tomail=$value[4]')\"><img src=$gIMG_Board/mail.gif border=0></a>";
             }
             print "</td>\n";


             print "<td nowrap align=center valign=middle width=90><font color=$gTableTextColor>$value[5]</font></td>\n"; # 
             
             if(($gFileUpload eq "checked") || ($gFileLink eq "checked")) {
                print "<td nowrap align=right valign=middle width=40><font color=$gTableTextColor>*</font>&nbsp;</td>\n";
             }

             print "<td nowrap align=right valign=middle width=40><font color=$gTableTextColor>*</font>&nbsp;</td></tr>\n";
             if(($gFileUpload eq "checked") || ($gFileLink eq "checked")) {
             	$gCols_Cnt = 6;
             }
             else {
             	$gCols_Cnt = 5;
             }
             print "<tr><td colspan=$gCols_Cnt width=100% height=3 background=\"$gIMG_Board/dot.gif\"></td></tr>\n";      
             print "</table>\n";
      }
   }
    print "</td></tr></table>\n";
}

##########################################################################
# ȭ鿡 Ŭ  
##########################################################################
sub read_file_content {	
    require "./lib/cm_get_date.cgi";	    
    require "./lib/bd_get_file_type.cgi";
    require "./lib/bd_call_img_viewer.cgi";        
    require "./lib/bd_get_emoticon.cgi";

    local($i,$j,$rec_color,$txt_color,$actual_number,$short_subject,$short_date,$old_date,$new_date);
    local(@datum,@data_fn,@value_fn,@value);
    
    &get_date;

    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);
       
    print "<table border=0 width=$gTableWidth cellspacing=0 cellpadding=0 valign=top align=center style=\"table-layout:fixed;\">\n";
    print "<tr><td>\n";

    
    for($i=1; $i<=$gNoOfData; $i++) {
        @data_fn = split(/\|/,$datum[$i]);       
        if(-e "$gBaseDIR/data/$data_fn[1].cgi") {
            open(HANDLE, "<$gBaseDIR/data/$data_fn[1].cgi");
              @value_fn = <HANDLE>;
            close(HANDLE);              	
         }
             
        @value = split(/\|/, $value_fn[0]);
        
        $actual_number = ($gNoOfData+1)-$i;                

         if($actual_number > 0) {                         	
             $date_length = length($date);
             $short_date = substr($value[5],0,20);
                
             # ̸Ƽ
             if($gShowEmoticon eq "checked") {
	        my $keyword = $value[6];
		$value[6] = &get_emoticon($keyword);
             }

            if(($FORM{'chk_name'} eq "on") && ($FORM{'chk_subject'} eq "on") && ($FORM{'chk_content'} eq "on")) { # ̸ +  + 
	           if($value[2] =~ /$FORM{'keyword'}/i) {
	              $value[2] =~ s/$FORM{'keyword'}/\<font\ color=red>$FORM{'keyword'}\<\/font\>/g;
	           }                            	
                   elsif($value[9] =~ /$FORM{'keyword'}/i) {
                      $value[9] =~ s/$FORM{'keyword'}/\<font\ color=red>$FORM{'keyword'}\<\/font\>/g;
                   }
	           elsif($value[6] =~ /$FORM{'keyword'}/i) {
	              $value[6] =~ /$FORM{'keyword'}/i;
                   }            
            }                                    
            elsif(($FORM{'chk_name'} eq "on") && ($FORM{'chk_subject'} eq "on")) {  # ̸ + 
	           if($value[2] =~ /$FORM{'keyword'}/i) {
	              $value[2] =~ s/$FORM{'keyword'}/\<font\ color=red>$FORM{'keyword'}\<\/font\>/g;  
	           }                            	
                   elsif($value[9] =~ /$FORM{'keyword'}/i) {
                      $value[9] =~ s/$FORM{'keyword'}/\<font\ color=red>$FORM{'keyword'}\<\/font\>/g;
                   }
            }
            elsif(($FORM{'chk_name'} eq "on") && ($FORM{'chk_content'} eq "on")) { # ̸ + 
	           if($value[2] =~ /$FORM{'keyword'}/i) {
	              $value[2] =~ s/$FORM{'keyword'}/\<font\ color=red>$FORM{'keyword'}\<\/font\>/g;          
	           }                            	
	           elsif($value[6] =~ /$FORM{'keyword'}/i) {
	              $value[6] =~ /$FORM{'keyword'}/i;
                   }
            }
            elsif(($FORM{'chk_subject'} eq "on") && ($FORM{'chk_content'} eq "on")) { #  +                             	
                   if($value[9] =~ /$FORM{'keyword'}/i) {
                      $value[9] =~ s/$FORM{'keyword'}/\<font\ color=red>$FORM{'keyword'}\<\/font\>/g;
                   }
	           elsif($value[6] =~ /$FORM{'keyword'}/i) {
	              $value[6] =~ /$FORM{'keyword'}/i;
                   }            
            }
            elsif($FORM{'chk_name'} eq "on") {            	
	       if($value[2] =~ /$FORM{'keyword'}/i) {
	             $value[2] =~ s/$FORM{'keyword'}/\<font\ color=red>$FORM{'keyword'}\<\/font\>/g;
	       }
            }         	
            elsif($FORM{'chk_subject'} eq 'on') {  
                if($value[9] =~ /$FORM{'keyword'}/i) {
                    $value[9] =~ s/$FORM{'keyword'}/\<font\ color=red>$FORM{'keyword'}\<\/font\>/g;
                }
            }
            elsif($FORM{'chk_content'} eq "on") { 
            	if($value[6] =~ /$FORM{'keyword'}/i) {
	          $value[6] =~ /$FORM{'keyword'}/i;
	        }
            }
                               
              if($FORM{'n'} eq $i) {

                
                print " <table border=0 cellpadding=0 cellspacing=0 width=100% align=left>\n";
                print "  <tr><td align=left valign=top colspan=2 style='word-break:break-all;'>\n";
                print "   <table border=1 cellpadding=0 cellspacing=0 width=100% align=left bordercolorlight=\"\" bordercolordark=$gActiveTableColor>\n";
                print "    <tr><td>\n";
                print "     <table border=0 bgcolor=$gTableBgColor cellpadding=3 cellspacing=0 width=100% align=left style=\"table-layout:fixed;\">\n";
                print "       <tr bgcolor=$gTableTitleBgColor><td align=left><img src=$gIMG_Board/speak.gif border=0>&nbsp;<font color=\"$gTableTitleTextColor\">$value[9]</font></td><td align=right><font color=\"$gTableTitleTextColor\">ȸ : $data_fn[11]&nbsp;</td></tr>";       

                print "<tr><td align=left colspan=2> ۼ : $value[2] ";                
                if($value[4] eq "") {      # ̸ 
                  if($value[8] ne "") {    # Ȩ 
                     print "<a href=$value[8] target=\"_blank\"><img src=$gIMG_Board/home.gif border=0 alt=\"$value[8]\"></a>";
                  }
                }
                else {  # ̸ 
                  if($value[8] eq "") { #Ȩ 
             	     if($COOKIE{'MEMBER_NAME'}) {    # ȸα Ǿ ȸ  
                        print "<a href=\"javascript:NewWin('200','200','300','309','MailWin','bdr_mail.cgi?fromname=$COOKIE{'MEMBER_NAME'}&frommail=$COOKIE{'MEMBER_EMAIL'}&tomail=$value[4]')\"><img src=$gIMG_Board/mail.gif border=0 alt=\"$value[4]\"></a>";
                     }
                     else {
                        print "<a href=\"javascript:NewWin('200','200','300','309','MailWin','bdr_mail.cgi?tomail=$value[4]')\"><img src=$gIMG_Board/mail.gif border=0 alt=\"$value[4]\"></a>";
                     }                  
                  }
                  else {
                     print "<a href=$value[8] target=\"_blank\"><img src=$gIMG_Board/home.gif border=0 alt=\"$value[8]\"></a> ";
             	     if($COOKIE{'MEMBER_NAME'}) {    # ȸα Ǿ ȸ  
                        print "<a href=\"javascript:NewWin('200','200','300','309','MailWin','bdr_mail.cgi?fromname=$COOKIE{'MEMBER_NAME'}&frommail=$COOKIE{'MEMBER_EMAIL'}&tomail=$value[4]')\">";
                     }
                     else {
                        print "<a href=\"javascript:NewWin('200','200','300','309','MailWin','bdr_mail.cgi?tomail=$value[4]')\">";
                     } 
                     print "<img src=$gIMG_Board/mail.gif border=0 alt=\"$value[4]\"></a>";
                  }
                }
                print "    </td></tr>\n";
                
                print "    <tr><td height=3 width=100% background=$gIMG_Board/dot.gif colspan=2> </td></tr>\n";
               
                # ε ȭ 
                if($value[12]) {                		
                  $Filetype = &get_file_type($value[12]);
                  print "    <tr><td colspan=2><img src=\"$gIMG_FileType/$Filetype\" border=0 height=16>&nbsp;<a href=bdr_board.cgi?db=$FORM{'db'}&action=download&l=$value[1]&d=$i&file=$value[12] target=_blank>$value[12]</a></td></tr>\n";
                }
                # ϸũ 
                if($value[3]) {
                  @FILENAME = split(/\//, $value[3]);
             	  $file_name = $FILENAME[$#FILENAME];                	
                  $Filetype = &get_file_type($value[3]);
                  print "    <tr><td colspan=2><img src=\"$gIMG_FileType/$Filetype\" border=0 height=16>&nbsp;<a href=bdr_board.cgi?db=$FORM{'db'}&action=download&l=$value[1]&d=$i&file=$value[3] target=_blank>$file_name (LINK)</a></td></tr>\n";
                }
                if($value[12] || $value[3]) {
                  print "    <tr><td height=3 width=100% background=$gIMG_Board/dot.gif colspan=2></td></tr>\n";
                }        
            
                print "    <tr><td colspan=2><font color=$gTableTextColor>\n<!--   -->\n";

                # ũ ̹ȭ 
                if($value[14]) {
                   &call_img_viewer($value[14]);
                   print "<br>\n";
                }
                                
                # ε ̹ȭ 
                if($value[13]) {
                   &call_img_viewer("$gUploadDIR/$value[13]");
                   print "<br>\n";
                }
                                
                #  
                print "\n$value[6]\n<!--   -->\n</font><br>\n";

                # ޸ 
                if($gWriteMemo eq "checked" ) {
            	   if(open(HANDLE, "<$gBaseDIR/data/$value[1].txt")) {
	                   @MEMO_DATA = <HANDLE>;
            	      close(HANDLE);
	     
            	      print "<p>";
            	      foreach  (@MEMO_DATA) {
	                     @MEMO_MSG = split(/\|/, $_);
             	         print "<table border=0 cellspacing=3 cellpadding=0 width=100% onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\"><tr>
                                  <td align=left valign=top width=80 nowrap><img src=$gIMG_Board/blank_face.gif border=0> <font color=$gTableTextColor style=font-family:tahoma;font-size:8pt>$MEMO_MSG[0] </font></td>
                                  <td align=left valign=top style='word-break:break-all;'><font color=$gTableTextColor style=font-family:tahoma;font-size:8pt>$MEMO_MSG[1] </font></td>
                                  <td align=right valign=top width=100 nowrap><font color=$gTableTextColor style=font-family:verdana;font-size:9px>$MEMO_MSG[3]&nbsp;</font></td>
                                  <td align=right valign=top width=90 nowrap><font color=#aaaaaa style=font-family:tahoma;font-size:8pt>$MEMO_MSG[2]</font></font></td>
                                 </tr></table>";
            	      }
            	   }

                   if(!($FORM{'action'} eq "show_only_content")) {   # bdr_list ޸𾲱⸦ 
               	      print "\n<!-- ޸ -->\n<center><form action=bdr_board.cgi method=post>
            		   <input type=hidden name=db value=$FORM{'db'}>
               		   <input type=hidden name=action value=memo_data>
            		   <input type=hidden name=p value=$FORM{'p'}>
            		   <input type=hidden name=n value=$FORM{'n'}>
            		   <input type=hidden name=l value=$value[1]>
                           <input type=hidden name=ip value=\"$ENV{'REMOTE_ADDR'}\">\n";

            	      print "<table border=0 cellspacing=1 cellpadding=0 width=96% align=center><tr>\n";
            	      if($COOKIE{'MEMBER_NAME'}) {	
            	         print "<td width=80><input type=hidden value=\"$COOKIE{'MEMBER_NAME'}\" name=name><table border=0 cellspacing=1 cellpadding=0 bgcolor=black width=80 height=18><tr><td><table width=100% bgcolor=$gTableBgColor cellspacing=0 cellpadding=1><tr><td><font color=$gTableTextColor>$COOKIE{'MEMBER_NAME'}</font></td></tr></table></td></tr></table></td>\n";
            	      }
            	      else {
            	         print "<td width=80><input type=text value=\"̸\" name=name maxlength=6 size=12 onBlur=\"checkField(this)\" onFocus=\"clearField(this)\" style=\'border:1 solid black; background-color:$gTableBgColor; color:$gTableTextColor; height:20px;\'></td>\n";
            	      }

            	      print "<td><input type=text value=\"޸\" name=comment maxlength=300 onBlur=\"checkField(this)\" onFocus=\"clearField(this)\" style=\'width:100%; border:1 solid black; background-color:$gTableBgColor; color:$gTableTextColor; height:20px;\'></td>
            	               <td width=50 align=left><input type=submit value=\"\" valign=absmiddle></td></center>\n\n";
            	      print "</tr></table></form>\n";  
		   }
            	}
	        
	        if($gShowIPInfo eq "checked") {
                   print "     <div align=right><font size=1 color=aaaaaa>$value[7]</font>&nbsp;&nbsp;</div>\n";
                }
                print "    </td></tr></table>\n";
                print "   </td></tr></table>\n";                
                print "   </td></tr>\n";

                if(($FORM{'action'} eq "show_only_content")) {  #bdr_list̸ ݱư 
                  print "   <tr><td colspan=2 align=center valign=middle height=30><table border=0 cellspacing=1 cellpadding=0 bgcolor=black width=50 height=18><tr><td><table width=100% bgcolor=$gTableBgColor cellspacing=0 cellpadding=1><tr><td align=center><font color=$gTableTextColor><a href=javascript:self.close()><img src=$gIMG_Board/close.gif border=0></a></font></td></tr></table></td></tr></table></td></tr>\n";
		}
		else {
                  print "  <tr><td align=left valign=top height=50><a href=bdr_board.cgi?db=$FORM{'db'}&action=r&p=$FORM{'p'}><img src=$gIMG_Board/list.gif border=0 alt=\"List\"></a></td>
                                <td align=right valign=top height=50><a href=bdr_board.cgi?db=$FORM{'db'}&action=show_user_input_form&p=$FORM{'p'}&c=show_update_form&n=$FORM{'n'}&l=$value[1]><img src=$gIMG_Board/reply.gif border=0 alt=\"Reply\"></a><a href=bdr_board.cgi?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=show_update_form&l=$value[1]><img src=$gIMG_Board/mod.gif border=0 alt=\"\"></a><a href=bdr_board.cgi?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=delete&l=$value[1]><img src=$gIMG_Board/del.gif border=0 alt=\"\"></a></td></tr>\n";
		}
                  print " </table>\n";
              }
         }
   }
    print "</td></tr></table>\n";
}

##########################################################################
# ȭ鿡 Ŭ  
##########################################################################
sub read_notice_file_content {
    require "./lib/cm_get_date.cgi";
    	
    local($k,$i,$j,$gNoOfNtc,$rec_color,$txt_color,$actual_number,$short_subject,$short_date,$old_date,$new_date);
    local(@datum,@data_fn,@value_fn,@value);

    &get_date;
    
    open(HANDLE,"$gBaseDIR/$gNtcFile");
        @datum = <HANDLE>;
    close(HANDLE);
    foreach(@datum) {
         $gNoOfNtc++;
    }

                    
    print "<table border=0 width=$gTableWidth cellspacing=0 cellpadding=0 valign=top align=center style=\"table-layout:fixed;\">\n";
    print "<tr><td>\n";
      
    for($k=1; $k<$gNoOfNtc; $k++) {
        @data_fn = split(/\|/,$datum[$k]);       
        if(-e "$gBaseDIR/data/$data_fn[1].cgi") {
            open(HANDLE, "<$gBaseDIR/data/$data_fn[1].cgi");
              @value_fn = <HANDLE>;
            close(HANDLE);              	
         }
             
        @value = split(/\|/, $value_fn[0]);

         if($gNoOfNtc-$k > 0) {
             $date_length = length($date);
             $short_date = substr($value[5],0,20);

             # ̸Ƽ
             if($gShowEmoticon eq "checked") {
	        my $keyword = $value[6];
		require "./lib/bd_get_emoticon.cgi";
		$value[6] = &get_emoticon($keyword);
             }
             
              if($FORM{'ntc'} eq $k) {
                print " <table border=0 cellpadding=0 cellspacing=0 width=100% align=left>\n";
                print "  <tr><td align=left valign=top colspan=2 style='word-break:break-all;'>\n";
                print "   <table border=1 cellpadding=0 cellspacing=0 width=100% align=left bordercolorlight=\"\" bordercolordark=$gActiveTableColor>\n";
                print "    <tr><td>\n";
                print "     <table border=0 bgcolor=$gTableBgColor cellpadding=3 cellspacing=0 width=100% align=left style=\"table-layout:fixed;\">\n";
                print "       <tr bgcolor=$gTableTitleBgColor><td align=left><img src=$gIMG_Board/speak.gif border=0>&nbsp;<font color=\"$gTableTitleTextColor\">$value[9]</font></td><td align=right></td></tr>";
                print "       <tr><td align=left colspan=2> ۼ : $value[2] </td></tr>\n";                               
                print "       <tr><td height=3 width=100% background=$gIMG_Board/dot.gif colspan=2> </td></tr>\n";
               
                if($value[12] || $value[3]) {
                  print "    <tr><td height=3 width=100% background=$gIMG_Board/dot.gif colspan=2></td></tr>\n";
                }        
                                     
                print "    <tr><td colspan=2><font color=$gTableTextColor>\n\n<!--   -->\n$value[6]\n<!--   -->\n</font><br>\n";
                if($gShowIPInfo eq "checked") {
                   print "     <div align=right><font size=1 color=aaaaaa>$value[7]</font>&nbsp;&nbsp;</div>\n";
                }
                print "    </td></tr></table>\n";
                print "   </td></tr></table>\n";                
                print "   </td></tr>\n";

                if(($FORM{'action'} eq "show_only_content")) {  #bdr_list̸ ݱư 
                  print "   <tr><td colspan=2 align=center valign=middle height=30><table border=0 cellspacing=1 cellpadding=0 bgcolor=black width=50 height=18><tr><td><table width=100% bgcolor=$gTableBgColor cellspacing=0 cellpadding=1><tr><td align=center><font color=$gTableTextColor><a href=javascript:self.close()>CLOSE</a></font></td></tr></table></td></tr></table></td></tr>\n";
		}
		else {
                  print "  <tr><td align=left valign=top height=50><a href=bdr_board.cgi?db=$FORM{'db'}&action=r&p=$FORM{'p'}><img src=$gIMG_Board/list.gif border=0 alt=\"List\"></a></td>
                                <td align=right valign=top height=50><a href=bdr_board.cgi?db=$FORM{'db'}&action=admin_login&p=$FORM{'p'}&c=show_notice_update_form&l=$value[1]><img src=$gIMG_Board/mod.gif border=0 alt=\"\"></a><a href=bdr_board.cgi?db=$FORM{'db'}&action=admin_login&p=$FORM{'p'}&c=delete_notice&l=$value[1]><img src=$gIMG_Board/del.gif border=0 alt=\"\"></a></td></tr>\n";
				}
                  print " </table>\n";
              }
         }
   }
    print "</td></tr></table>\n";
}

##########################################################################
# ޸𾲱
##########################################################################
sub MemoData {
       local($data);
       local(@datum,@value);    

       require "./lib/cm_lock.cgi";
       require "./lib/cm_alert.cgi";
       require "./lib/cm_get_date.cgi";
       &get_date;

       if($FORM{'name'} ne "̸" ) {
          $FORM{'name'} =~ s/</&lt;/g;
          $FORM{'name'} =~ s/>/&gt;/g;
          $FORM{'name'} =~ s/"/&quot;/g;
          $FORM{'name'} =~ s/\|/&#124;/g;
       }
       else {
          $msg = "̸ Է ּ"; 
          alert($msg);
       }
	
       if($FORM{'comment'} ne "޸" ) {
          $FORM{'comment'} =~ s/</&lt;/g;
          $FORM{'comment'} =~ s/>/&gt;/g;
          $FORM{'comment'} =~ s/"/&quot;/g;
          $FORM{'comment'} =~ s/\|/&#124;/g;
       }
       else {
          $msg = " Է ּ"; 
          alert($msg);
       }

       if($FORM{'ip'} eq "") {
        $ip = $ENV{'REMOTE_ADDR'};
       }
       else {
          $ip = "$FORM{'ip'}";
          $ip =~ s/\|/&#124;/g;
       }
 
       &lock("$FORM{'db'}_memo");
       if(-e "$gBaseDIR/data/$FORM{'l'}.txt") {
          open(HANDLE, "<$gBaseDIR/data/$FORM{'l'}.txt");
            @MEMO_DATA = <HANDLE>;
          close(HANDLE);
                    
          open(HANDLE, ">$gBaseDIR/data/$FORM{'l'}.txt");                    
           print HANDLE "$FORM{'name'}|$FORM{'comment'}|$today|$ip|\n";
           foreach  (@MEMO_DATA) {
               print HANDLE "$_";
           }
          close(HANDLE);
       }
       else {
          open(HANDLE, ">$gBaseDIR/data/$FORM{'l'}.txt");
            print HANDLE "$FORM{'name'}|$FORM{'comment'}|$today|$ip|\n";
          close(HANDLE);         
       }
       &unlock("$FORM{'db'}_memo");	
       
       print "CONTENT-TYPE:TEXT/HTML\n\n";
       print "<html>
              <meta http-equiv=\"refresh\" content=\"0;url=bdr_board.cgi?db=$FORM{'db'}&action=show_content&n=$FORM{'n'}&p=$FORM{'p'}&l=$FORM{'l'}&mode=memo\">
              </html>";
       exit;	
}

##########################################################################
# 
##########################################################################
sub go_prev_next_page {
       print "<table border=0 cellpadding=9 cellspacing=1 align=center valign=top><tr><td align=center>\n";
       $term = $gListNumber;
       $f = 1;
       $l = $term;
       
       while($f <= $gTotPage) {
             if(($f <= $gCurPage) && ($gCurPage <= $l)) {
                  $prevp = $f - 1;

                 if ($prevp > 0) {
                      print "<a href=bdr_board.cgi?db=$FORM{'db'}&action=r&p=$prevp title='$prevp page'><img src=$gIMG_Board/prev_page.gif border=0></a>";
                 }
                  
                 if($l <= $gTotPage) {
	     for($page = $f; $page <= $l; $page++) {
	         if($page == $gCurPage) {
                            print "<span style=\"background-color:#adadad;\">&nbsp;<b class=page_move1>$page</b>&nbsp;</span>&nbsp;";
	         }
                         else {
                            print "<span style=\"background-color:#cfcfcf;\"><a href=bdr_board.cgi?db=$FORM{'db'}&action=r&p=$page title='$page page'>&nbsp;<b class=page_move2>$page</b>&nbsp;</a></span>&nbsp;";
                         }
                    }
                 }
                 else {
                    for($page = $f; $page <= $gTotPage; $page++) {
	         if($page == $gCurPage) {
                            print "<span style=\"background-color:#adadad;\">&nbsp;<b class=page_move1>$page</b>&nbsp;</span>&nbsp;";
                         }
                         else {
                            print "<span style=\"background-color:#cfcfcf;\"><a href=bdr_board.cgi?db=$FORM{'db'}&action=r&p=$page title='$page page'>&nbsp;<b class=page_move2>$page</b>&nbsp;</a></span>&nbsp;";
                         }
                    }
                 }
                 $nextp = $l + 1;
                 
  	 if($nextp <= $gTotPage) {
                    print "<a href=bdr_board.cgi?db=$FORM{'db'}&action=r&p=$nextp title='$nextp page'><img src=$gIMG_Board/next_page.gif border=0></a>";
                 }
           }
           $f = $f + $term;
           $l = $l + $term;
     }
     print "</td></tr></table>\n";
}

##########################################################################
#  ۾ 
##########################################################################
sub show_user_input_form {    	
    require "./lib/cm_html_head.cgi";
    require "./lib/cm_get_date.cgi";
    require "./lib/cm_get_cookie.cgi";    
        	
    local($data,$subject,$content,$name,$value,$subject_len);
    local(@value,@cookies);
    
    &get_date; 
    &get_cookie;
    &html_head("bdr_board");

    if($FORM{'l'}) {         #   
       open(HANDLE, "$gBaseDIR/data/$FORM{'l'}.cgi");
          $data = <HANDLE>;
       close(HANDLE);
        
       @value = split(/\|/,$data);
       $subject = "Re: $value[9]";
       $content = "&gt;$value[6]\n";
       $content =~ s/<br>/\n&gt;/g;
       $content =~ s/<p>/\n&gt;\n&gt;/g;
    }
    
    if(!-e "./members/logon/$COOKIE{'MEMBER_ID'}.cgi") {
       $gIsMember = false;	
    }
    else {
       $gIsMember = true;	
    }

    print "<form method=post name=inputForm action=bdr_board.cgi enctype=multipart/form-data>\n";    
    print "<br><table border=1 width=450 bgcolor=#eeeeee bordercolorlight=#cccccc bordercolordark=#ffffff cellspacing=0 cellpadding=5 align=center>\n";
    print "<tr><td align=center>\n";

    print "<table border=0 cellspacing=1 cellpadding=2>\n";    
    print "<input type=hidden name=db value=$FORM{'db'}>\n";
    print "<input type=hidden name=action value=write>\n";
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=n value=$FORM{'n'}>\n";
    print "<input type=hidden name=l value=$FORM{'l'}>\n";
    print "<input type=hidden name=receiver value=$value[4]>\n";

    if($gShowEmoticon eq "checked") {
    	  $subject_len = 35;
    }
    else {
    	  $subject_len = 45;
    }
                         
    if($gIsMember eq "true") {
       print "<input type=hidden name=passwd value=$COOKIE{'MEMBER_PW'}>\n";
       print "<tr><td align=right><span class=cls><b>Name</b></span></td><td>\n";
       print "<input name=name type=text size=53 maxlength=4 value='$COOKIE{'MEMBER_NAME'}' class=text readonly></td></tr>\n";
       print "<tr><td align=right><span class=cls><b>E-Mail</b></span></td><td>\n";
       print "<input name=email type=text size=53 maxlength=30 value='$COOKIE{'MEMBER_EMAIL'}' class=text readonly></td></tr>\n";
       print "<tr><td align=right><span class=cls><b>Homepage</b></span></td><td>\n";
       print "<input name=homepage type=text size=53 maxlength=53 value='$COOKIE{'MEMBER_HOMEPAGE'}' class=text readonly></td></tr>\n";     
       print "<tr><td align=right><span class=cls><b>Subject</b></span></td><td>\n";
       print "<input type=text name=subject value=\"$subject\" class=text size=$subject_len maxlength=45> <input type=checkbox name=html value=checked style=\"background-color:#eeeeee;border:0\">html\n";
       
       if($gShowEmoticon eq "checked") {
          print "<a href=javascript:NewWin('200','200','240','280','EmoticonWin','bdr_board.cgi?db=$FORM{'db'}&action=insert_emoticon')><img src=$gIMG_Emoticon/emoticon.gif border=0 alt=\"̸Ƽ\"></a>\n";
       }           
       print "<input type=hidden name=ip value=\"$ENV{'REMOTE_ADDR'}\">\n";                              # Ӽ : ip    
       print "<input type=hidden name=date value=\"$date\">\n";                          # Ӽ : ¥            
       print "</td></tr>\n";         
       if($content eq "") {
          print "<tr><td align=right valign=top><span class=cls><b>Content</b></span></td><td><textarea name=content rows=15 cols=52 class=comment></textarea></td>\n";
       }
       else {
         print "<tr><td align=right valign=top><span class=cls><b>Content</b></span></td><td><textarea name=content rows=15 cols=52 class=comment>$content</textarea></td>\n";       	
       }       
       print "</tr>\n";
       if($gFileImgLink eq "checked") {
          print "<tr><td align=right valign=top><span class=cls><b>Image Link</b></span></td><td><input type=text name=fileimglink value='http://' class=text size=53></td></tr>\n";
       }              
       if($gFileLink eq "checked") {
          print "<tr><td align=right valign=top><span class=cls><b>File Link</b></span></td><td><input type=text name=filelink value='http://' class=text size=53></td></tr>\n";
       }
       if($gFileUpload eq "checked") {
          print "<tr><td align=right valign=top><span class=cls><b>File Upload</b></span></td><td><input type=file name=fileupload value='' size=43 class=file></td></tr>\n";
       }
       if($gFileImgUpload eq "checked") {
          print "<tr><td align=right valign=top><span class=cls><b>Screen Shot</b></span></td><td><input type=file name=fileimgupload value='' size=43 class=file></td></tr>\n";
       }       
       if($FORM{'l'} && $value[4]) {         #   ̰, ̸ּ  亯 
          print "<tr><td align=right valign=top colspan=2><input type=checkbox name=replymail value=checked checked style=\"background-color:$gBackColor;border:0\"> <a href=\"mailto:$value[4]\" title=$value[4]>$value[2]</a>Կ 亯 Ϻ</td></tr>\n";
       }        
       
       print "<tr><td align=center colspan=2><input type=submit value=\" Ȯ  \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"> <input type=reset value=\" Է \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"></td>\n";
       print "</tr></table>\n";
       print "</td></tr></table>\n";
       print "</form>\n";
       print "<script language=\"javascript\">document.inputForm.subject.focus();</script>\n";
   }
   else {   # Ϲݸ     
       print "<tr><td align=right><span class=cls><b>Password</b></span></td>\n";
       print "<td><input type=password name=passwd size=53 maxlength=12 value='' class=text></td></tr>\n";
       print "<tr><td align=right><span class=cls><b>Name</b></span></td><td>\n";
       print "<input name=name type=text size=53 maxlength=4 value='' class=text>\n";
       print "</td></tr>\n";    
       print "<tr><td align=right><span class=cls><b>E-Mail</b></span></td><td>\n";
       print "<input name=email value='' maxlength=30 type=text size=53 class=text></td></tr>\n";                    
       print "<tr><td align=right><span class=cls><b>Homepage</b></span></td><td>\n";
       print "<input name=homepage type=text value='http://' maxlength=53 size=53 class=text></td></tr>\n";     
       print "<tr><td align=right><span class=cls><b>Subject</b></span></td><td>\n";
       print "<input type=text name=subject value=\"$subject\" class=text size=$subject_len maxlength=45> <input type=checkbox name=html value=checked style=\"background-color:#eeeeee;border:0\">html\n";

       if($gShowEmoticon eq "checked") {
          print "<a href=javascript:NewWin('200','200','240','280','EmoticonWin','bdr_board.cgi?db=$FORM{'db'}&action=insert_emoticon')><img src=$gIMG_Emoticon/emoticon.gif border=0 alt=\"̸Ƽ\"></a>\n";
       }    
       print "<input type=hidden name=ip value=\"$ENV{'REMOTE_ADDR'}\">\n";                                # Ӽ : ip    
       print "<input type=hidden name=date value=\"$date\">\n";                              # Ӽ : ¥            
       print "</td></tr>\n";         
       if($content eq "") {
          print "<tr><td align=right valign=top><span class=cls><b>Content</b></span></td><td><textarea name=content rows=15 cols=52 class=comment></textarea></td>\n";
       }
       else {
         print "<tr><td align=right valign=top><span class=cls><b>Content</b></span></td><td><textarea name=content rows=15 cols=52 class=comment>$content</textarea></td>\n";
       }
       print "</tr>\n";
       if($gFileImgLink eq "checked") {
          print "<tr><td align=right valign=top><span class=cls><b>Image Link</b></span></td><td><input type=text name=fileimglink value='http://' class=text size=53></td></tr>\n";
       }              
       if($gFileLink eq "checked") {
          print "<tr><td align=right valign=top><span class=cls><b>File Link</b></span></td><td><input type=text name=filelink value='http://' class=text size=53></td></tr>\n";
       }
       if($gFileUpload eq "checked") {
          print "<tr><td align=right valign=top><span class=cls><b>File Upload</b></span></td><td><input type=file name=fileupload value='' size=43 class=file></td></tr>\n";
       } 
       if($gFileImgUpload eq "checked") {
          print "<tr><td align=right valign=top><span class=cls><b>Screen Shot</b></span></td><td><input type=file name=fileimgupload value='' size=43 class=file></td></tr>\n";
       } 
       
       if($FORM{'l'} && $value[4]) {         #   ϰ, ̸ּ  亯 
          print "<tr><td align=right valign=top colspan=2><input type=checkbox name=replymail value=checked checked style=\"background-color:#eeeeee;border:0\"> <a href=\"mailto:$value[4]\" title=$value[4]>$value[2]</a>Կ 亯 Ϻ</td></tr>\n";
       }        
              
       print "<tr><td align=center colspan=2><input type=submit value=\" Ȯ  \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"> <input type=reset value=\" Է \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"></td>\n";
       print "</tr></table>\n";
       print "</td></tr></table>\n";
       print "</form>\n";
       print "<script language=\"javascript\">document.inputForm.passwd.focus();</script>\n";	
   }    
    
    &html_foot;
}

################################################################################[ ]
sub show_notice_input_form {
    require "./lib/cm_get_date.cgi";    
    require "./lib/cm_get_cookie.cgi";
    
    local($data,$subject,$content,$name,$value,$subject_len);
    local(@value,@cookies);

    &get_date; 
    &get_cookie;
    print "Content-type: text/html\n\n";
    print "<html><head>\n";
    print "<meta http-equiv=\"description\" name=\"description\" content=\"text/html; charset=KS_C_5601-1987; charset=euc-kr\">\n";        
    print "<style type='text/css'>\n";
    print "<!--\n";	
    print " BODY {background:url(\"$gBackImgURL\") $gBackColor fixed no-repeat 98% 98%}\n";
    print "-->\n";    
    print "</style>\n";
    print "    
    <script language=\"JavaScript\">
    <!--           
      function NewWin(Left,Top,Width,Height,Name,URL) { 
        window.open(URL,Name,'resizable=no,scrollbars=no,status=0,toolbar=no,location=no,directories=no,menubar=no,left='+Left+',top='+Top+',width='+Width+',height='+Height);
      }
    -->
    </script>";
    print "<link rel=\"stylesheet\" type=\"text/css\" href=\"./bdr_board.css\">\n";
    print "</head>\n";
    print "<body bgcolor=$gBackColor topmargin=0 leftmargin=0 topmargin=0 leftmargin=0 oncontextmenu='return true'><br>\n";    
    print "<form method=post name=inputForm action=bdr_board.cgi>\n";
    print "<br><table border=1 width=400 bgcolor=#eeeeee bordercolorlight=#cccccc bordercolordark=#ffffff cellspacing=0 cellpadding=5 align=center>\n";
    print "<tr><td align=center>\n";
    print "<table border=0 bgcolor=efefef cellspacing=1 cellpadding=2>\n";    
    print "<input type=hidden name=db value=$FORM{'db'}>\n";
    print "<input type=hidden name=action value=write_notice>\n";
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=n value=$FORM{'n'}>\n";
    print "<input type=hidden name=l value=$FORM{'l'}>\n";       
    print "<input type=hidden name=mode value=notice>\n";
    print "<input type=hidden name=name type=text size=20 value='' class=text maxlength=8>\n";
    print "<tr><td align=right><span class=cls><b>Subject</b></span></td><td>\n";       
    if($gShowEmoticon eq "checked") {
    	  $subject_len = 35;
    }
    else {
    	  $subject_len = 45;
    }    
    print "<input type=text name=subject value='' class=text size=$subject_len maxlength=40> <input type=checkbox name=html value=checked style=\"background-color:#efefef;border:0\">html\n";
    if($gShowEmoticon eq "checked") {
       print "<a href=javascript:NewWin('660','200','240','280','EmoticonWin','bdr_board.cgi?db=$FORM{'db'}&action=insert_emoticon')><img src=$gIMG_Emoticon/emoticon.gif border=0 alt=\"̸Ƽ\"></a>\n";
    }       
    print "<input type=hidden name=ip value=\"$ENV{'REMOTE_ADDR'}\">\n";    # Ӽ : ip    
    print "<input type=hidden name=date value=\"$date\">\n";                # Ӽ : ¥            
    print "</td></tr>\n";         
    print "<tr><td align=right valign=top><span class=cls><b>Content</b></span></td><td><textarea name=content rows=15 cols=52 class=comment></textarea style=\"overflow:auto;\"></td>\n";
    print "</tr>\n";
    print "<tr><td align=right colspan=2><input type=image src=$gIMG_CGI/submit.gif title=\"Ȯ\" border=0><a href=\"javascript:window.close();\"><img src=$gIMG_CGI/close.gif border=0 title=\"ݱ\"></a><br><br></td>\n";
    print "</tr></table>\n";
    print "</td></tr></table>\n";
    print "</form>\n";
    print "<script language=\"javascript\">document.inputForm.subject.focus();</script>\n";	
    print "</body>\n";
    print "</html>\n";
    exit;
}	

################################################################################[ε ]
sub saveFile {	
    local($t,$UpFile,$filename,$temp_filename);
    local(@x,@y,@chk_char);
    
    require "./lib/cm_lock.cgi";
    require "./lib/cm_alert.cgi";
    
    my($UpFile,$file_num) = @_;
    chop($UpFile);
    chop($UpFile);    
    @x = split(/\"/, $uploadfile[$file_num]);
    @y = split(/\\/,$x[3]);
    $t = @y;
    $filename = ($y[$t-1]);
        	
    #Ư  (̹ũ  ȵǱ )
    @chk_char = qw(\` \! \@ \# \% \& \+ \= \');
    foreach (@chk_char) {
    	$filename =~ s/$_//g; 
    } 
    	
    @F_N = split(/\./, $filename);
    if($F_N[$#F_N] =~ /htm|ph/i ) {
    	$msg = "˼մϴ. PHP/HTML  Ȼ εϽ  ϴ. Ŀ ε ּ"; 
    	alert($msg);
    }
    
    if(-e "$gUploadDIR/$filename") {
    	$msg = "εϽ ($filename) ε丮($gUploadDIR) ̹ մϴ."; 
    	alert($msg);
    }
    else {    		
    	&lock("$FORM{'db'}_upload");
    	local($SAVE_UPFILE);
    	$SAVE_UPFILE = "$gUploadDIR/$filename";
    	open(FILE,">$SAVE_UPFILE");
    	  binmode FILE;
    	  print FILE $UpFile;
    	close FILE;
    	&unlock("$FORM{'db'}_upload");
    	 
    	$fsize = (-s "$gUploadDIR/$filename");
    	if($fsize > $gMaxFileSize*1048576) {
    	   unlink("$gUploadDIR/$filename");
    	   $fsize = int($fsize/102.4)/10;
    	   $msg = " ũ($fsize MB) ($gMaxFileSize MB) Ůϴ."; 
    	   alert($msg);
    	}
    }
}

##########################################################################
# ȭϿ Է  Ѵ.
##########################################################################
sub write_data {	
    require "./lib/cm_make_crypt_password.cgi";
    require "./lib/cm_get_num_info.cgi";
    require "./lib/cm_put_num_info.cgi";
    
    &get_num_info;
    &getVariable;    
    &make_crypt_password if($passwd);    
    &saveFile("$FORM{'fileupload'}","0") if($fname);      # ȭ ε    
    &saveFile("$FORM{'fileimgupload'}","1") if($finame);  # ̹ȭ ε    
    &makeNewFile;
    &appendIndexFile;
    $gNoOfData++;
    &put_num_info($gNoOfData);
    
    if($FORM{'replymail'} eq "checked") {
       &ReplyMail;
    }

    print "Content-type: text/html\n\n";
    print "<html>\n";
    print "<meta http-equiv=refresh content=0;url=bdr_board.cgi?db=$FORM{'db'}&action=r&p=$FORM{'p'}>\n";
    print "</html>\n";    
}

##########################################################################
#  Է  .
##########################################################################
sub write_notice_data {
    require "./lib/cm_get_num_info.cgi";
    
    &get_num_info;
    &getVariable;
    &makeNewFile;
    &appendNoticeIndexFile;
    
    print "Content-type: text/html\n\n";
    print "<html>\n";
    print "<head>\n<title>Beomdori's Board $gVerBoard</title>\n";    
    print "<meta http-equiv=\"description\" name=\"description\" content=\"text/html; charset=KS_C_5601-1987; charset=euc-kr\">\n";        
    print "<link rel=\"stylesheet\" type=\"text/css\" href=\"./bdr_board.css\">\n";
    print "		
	   <script language=javascript>
	     setTimeout('window.close()', 2000);
	   </script>
    ";
    $gBackColor = "#ffffff" unless($gBackColor);
    print "<body bgcolor=$gBackColor topmargin=0 leftmargin=0 oncontextmenu='return false'>\n";
    print "<br><br><center><table bgcolor=#efefef width=80% height=80% border=1><tr><td align=center><br><b> ϴ.<br> â 2 Ŀ ڵ ϴ.</b><br><br><a href=javascript:self.close()><img src=$gIMG_Board/close.gif border=0></a></td></tr></table></center>";
    print "</body></html>\n";    
}

##########################################################################
# Է  ´
##########################################################################
sub getVariable {
    require "./lib/cm_alert.cgi";
    require "./lib/bd_get_file_type.cgi";
    require "./lib/cm_get_date.cgi";    	    
    	
    local($t,$filename);
    local(@x,@y);
    
# ȣ	
    if(($FORM{'passwd'}) || ($FORM{'OldPassword'})) {
        $passwd = "$FORM{'passwd'}";
    }
    else {
    	unless($FORM{'mode'} eq "notice") {
          $msg = "ȣ ݵ ּ."; 
          alert($msg);
        }
    }
    
# ̸
    unless($FORM{'name'} =~ /^\s*$/) {
        $name = "$FORM{'name'}";
        $name =~ s/\|/&#124;/g;
        $name =~ s/\r\n/<br>/g;
    }
    else {
        $msg = "̸ ݵ ּ."; 
        alert($msg);
    }

# 
    if($FORM{'content'}) {
       $content = "$FORM{'content'}";
        if($FORM{'html'} ne "checked") {
            $content =~ s/</&lt;/g;
            $content =~ s/>/&gt;/g;
            $content =~ s/"/&quot;/g;
        }
        $content =~ s/\|/&#124;/g;
        $content =~ s/\r\n\r\n/<p>/g;
        $content =~ s/\r\n/<br>/g;
    }
    else {
        $msg = " ݵ ּ."; 
        alert($msg);
    }

# 
    if($FORM{'subject'}) {
       $subject = "$FORM{'subject'}";
       $subject =~ s/\|/&#124;/g;
       $subject =~ s/\r\n/<br>/g;
    }
    else {
        $msg = " ݵ ּ."; 
        alert($msg);
    }
        
# ̸
    if($FORM{'email'}) {
        $email = "$FORM{'email'}";
        $email =~ s/\|/&#124;/g;
    }
    else {
        $email = "";
    }
    
# Ȩ
    if($FORM{'homepage'}) {
       if($FORM{'homepage'} eq 'http://') {
       	  $homepage = "";
       }
       else {
          $homepage = "$FORM{'homepage'}";
          $homepage =~ s/\|/&#124;/g;
        }
    }
    
# ϸũ
    if($FORM{'filelink'}) {
       if($FORM{'filelink'} eq 'http://') {
       	  $filelink = "";
       }
       else {
          $filelink = "$FORM{'filelink'}";
          $filelink =~ s/\|/&#124;/g;
        }
    }

# ̹ũ
    if($FORM{'fileimglink'}) {
       if($FORM{'fileimglink'} eq 'http://') {
       	  $fileimglink = "";
       }
       else {
          @FILENAME = split(/\//, $FORM{'fileimglink'});
   	  $file_name = $FILENAME[$#FILENAME];                	
          $Filetype = &get_file_type($FORM{'fileimglink'});
          if(!(($Filetype eq "gif.gif") || ($Filetype eq "jpg.gif") || ($Filetype eq "swf.gif"))) {
             $msg = "̹ ε Jpg, Gif, Swf մϴ."; 
             alert($msg);                	
          }
          $fileimglink = "$FORM{'fileimglink'}";
          $fileimglink =~ s/\|/&#124;/g;
        }
    }
    
# Ͼε   
    if($FORM{'fileupload'}) {
       @x = split(/\"/, $uploadfile[0]);
       @y = split(/\\/,$x[3]);
       $t = @y;
       $filename = ($y[$t-1]);
       $fname = "$filename";
    }
    elsif($FORM{'update_fileupload'}) {
       $fname = $FORM{'update_fileupload'};
    }
    else {
       $fname = "";
    }
    
# ̹Ͼε    	
    if($FORM{'fileimgupload'}) {    	
        @x = split(/\"/,$uploadfile[1]);
        @y = split(/\\/,$x[3]);    	        
        $t = @y;
        $filename = ($y[$t-1]);
        $finame = "$filename";
        
        $Filetype = &get_file_type($finame);
        if(!(($Filetype eq "gif.gif") || ($Filetype eq "jpg.gif"))) {
           $msg = "̹ ε Jpg, Gif մϴ."; 
           alert($msg);                	
        }
    }
    elsif($FORM{'update_fileimgupload'}) {
       $finame = $FORM{'update_fileimgupload'};
    }    
    else {
        $finame = "";
    }
    
# ¥
    if($FORM{'date'} eq "") {
        &get_date;            
    }
    else {
        $date = "$FORM{'date'}";
        $date =~ s/\|/&#124;/g;
    }

# IP    
    if($FORM{'ip'} eq "") {
        $ip = $ENV{'REMOTE_ADDR'};
    }
    else {
        $ip = "$FORM{'ip'}";
        $ip =~ s/\|/&#124;/g;
    }        
}

##########################################################################
# ˻
##########################################################################
sub show_search_form {			
    if(($FORM{'chk_name'} eq "") && ($FORM{'chk_subject'} eq "") && ($FORM{'chk_content'} eq "")) {
	$FORM{'chk_name'} = "off";
	$FORM{'chk_subject'} = "on";
	$FORM{'chk_content'} = "on";
    }
	
    $s_name_img = (($FORM{'chk_name'}) eq "on") ? "s_chk_name.gif" : "s_name.gif";
    $s_subject_img = (($FORM{'chk_subject'}) eq "on") ? "s_chk_subject.gif" : "s_subject.gif";
    $s_content_img = (($FORM{'chk_content'}) eq "on") ? "s_chk_content.gif" : "s_content.gif";
		
    if($gAlignType ne "center") {
       print "<br>\n<br>\n<br>";
    }
    print "\n<!-- ˻  -->
 <script language=javascript>
  function chg_chk(chg_val) {
     if(chg_val == \"name\") {
	if(document.searchForm.chk_name.value == \"on\") {
	   document.images['s_name'].src = \"$gIMG_Board/s_name.gif\";
	   document.searchForm.chk_name.value = \"off\";
	}
	else {
	   document.images['s_name'].src = \"$gIMG_Board/s_chk_name.gif\";
	   document.searchForm.chk_name.value = \"on\";
	}
     }
     if(chg_val == \"subject\") {
        if(document.searchForm.chk_subject.value == \"on\") {
	   document.images['s_subject'].src = \"$gIMG_Board/s_subject.gif\";
	   document.searchForm.chk_subject.value = \"off\";
	}
	else {
	   document.images['s_subject'].src = \"$gIMG_Board/s_chk_subject.gif\";
	   document.searchForm.chk_subject.value = \"on\";
	}
     }
     if(chg_val == \"content\") {
	if(document.searchForm.chk_content.value == \"on\") {
	   document.images['s_content'].src = \"$gIMG_Board/s_content.gif\";
	   document.searchForm.chk_content.value = \"off\";
	}
	else {
	   document.images['s_content'].src = \"$gIMG_Board/s_chk_content.gif\";
	   document.searchForm.chk_content.value = \"on\";
	}
     }
  }
 </script>\n\n";
        
    print " <form method=post name=searchForm action=bdr_board.cgi>\n";
    print " <table border=0 width=400 cellspacing=0 cellpadding=1 align=center>\n";
    print " <input type=hidden name=db value=$FORM{'db'}>\n";
    print " <input type=hidden name=action value=search>\n";
    print " <input type=hidden name=p value=$gCurPage>\n";
    print " <input type=hidden name=chk_name value=$FORM{'chk_name'}>\n";
    print " <input type=hidden name=chk_subject value=$FORM{'chk_subject'}>\n";
    print " <input type=hidden name=chk_content value=$FORM{'chk_content'}>\n";
    print " <tr>\n";
    print " <td align=center valign=top>\n";
    print " <a href=\"javascript:chg_chk('name')\" onfocus=\"blur();\"><img src=$gIMG_Board/$s_name_img name=s_name border=0 alt=\"̸\"></a>
 <a href=\"javascript:chg_chk('subject')\" onfocus=\"blur();\"><img src=$gIMG_Board/$s_subject_img name=s_subject border=0 alt=\"\"></a>
 <a href=\"javascript:chg_chk('content')\" onfocus=\"blur();\"><img src=$gIMG_Board/$s_content_img name=s_content border=0 alt=\"\"></a>";
    print "<br><input type=text size=20 name=keyword maxlength=20 style=\"height:14pt\">\n";
    print "<input type=image src=$gIMG_Board/search.gif alt=\" :: ˻ :: \" border=0 valign=\"absmiddle\">\n";
    print "</td></tr></table>\n";
    print "</form>\n<!-- ˻  -->\n\n";
}

##########################################################################
# ˻ϱ
##########################################################################
sub search_data {
    local($data);
    local(@datum,@value,@data_fn,@value_fn);    
       	   
    unless($FORM{'keyword'}) {
        print "<center><font color=red><b>˻ Է ʾҽϴ.</b></font></center><br>\n";
    }
    elsif(($FORM{'chk_name'} eq "off") && ($FORM{'chk_subject'} eq "off") && ($FORM{'chk_content'} eq "off")) {
        print "<center><font color=red><b>ϳ ̻ ˻ üũؾ մϴ.</b></font></center><br>\n";
    }
    else {
        open(HANDLE,"$gBaseDIR/$gDatFile");
            @datum = <HANDLE>;
        close(HANDLE);

        $cnt = 0;       
        
        print "<table border=0 width=$gTableWidth cellspacing=0 cellpadding=0 valign=top align=center>\n";
        print "<tr><td>\n";
    
        for($i=1;$i<=$gNoOfData;$i++ ) {
           @data_fn = split(/\|/,$datum[$i]);        	       
           if(-e "$gBaseDIR/data/$data_fn[1].cgi") {
              open(HANDLE, "<$gBaseDIR/data/$data_fn[1].cgi");
                @value_fn = <HANDLE>;
              close(HANDLE);              	
           }
             
          @value = split(/\|/, $value_fn[0]);               

           if(($FORM{'chk_name'} eq "on") && ($FORM{'chk_subject'} eq "on") && ($FORM{'chk_content'} eq "on")) { # ̸ +  + 
	           if($value[6] =~ /$FORM{'keyword'}/i) {
                      &printRecord;
                      $cnt++;                      	       
                   }
                   elsif($value[9] =~ /$FORM{'keyword'}/i) {
                      $value[9] =~ s/$FORM{'keyword'}/\<font\ color=red>$FORM{'keyword'}\<\/font\>/g;
                      &printRecord;
                      $cnt++;
                   }                   
	           elsif($value[2] =~ /$FORM{'keyword'}/i) {
	              $value[2] =~ s/$FORM{'keyword'}/\<font\ color=red>$FORM{'keyword'}\<\/font\>/g;
                      &printRecord;
                      $cnt++;                     
	           }                            	
            }                                    
            elsif(($FORM{'chk_subject'} eq "on") && ($FORM{'chk_name'} eq "on")) {  #  + ̸
                   if($value[9] =~ /$FORM{'keyword'}/i) {
                      $value[9] =~ s/$FORM{'keyword'}/\<font\ color=red>$FORM{'keyword'}\<\/font\>/g;
                      &printRecord;
                      $cnt++;
                   }            	
	           elsif($value[2] =~ /$FORM{'keyword'}/i) {
	              $value[2] =~ s/$FORM{'keyword'}/\<font\ color=red>$FORM{'keyword'}\<\/font\>/g;
                      &printRecord;
                      $cnt++;                     
	           }                            	
            }
            elsif(($FORM{'chk_content'} eq "on") && ($FORM{'chk_name'} eq "on")) {  #  + ̸
	           if($value[6] =~ /$FORM{'keyword'}/i) {
                      &printRecord;
                      $cnt++;                      	       
                   }                        	
	           elsif($value[2] =~ /$FORM{'keyword'}/i) {
	              $value[2] =~ s/$FORM{'keyword'}/\<font\ color=red>$FORM{'keyword'}\<\/font\>/g;
                      &printRecord;
                      $cnt++;                     
	           }                            	
            }
            elsif(($FORM{'chk_subject'} eq "on") && ($FORM{'chk_content'} eq "on")) { #  +                             	
                   if($value[9] =~ /$FORM{'keyword'}/i) {
                      $value[9] =~ s/$FORM{'keyword'}/\<font\ color=red>$FORM{'keyword'}\<\/font\>/g;
                      &printRecord;
                      $cnt++;
                   }
	           elsif($value[6] =~ /$FORM{'keyword'}/i) {
                      &printRecord;
                      $cnt++;                      	       
                   }            
            }
           elsif($FORM{'chk_name'} eq "on") {            	
	       if($value[2] =~ /$FORM{'keyword'}/i) {
	             $value[2] =~ s/$FORM{'keyword'}/\<font\ color=red>$FORM{'keyword'}\<\/font\>/g;
                     &printRecord;
                     $cnt++;                     
	       }
            }         	
            elsif($FORM{'chk_subject'} eq 'on') {  
                if($value[9] =~ /$FORM{'keyword'}/i) {
                    $value[9] =~ s/$FORM{'keyword'}/\<font\ color=red>$FORM{'keyword'}\<\/font\>/g;
                    &printRecord;
                    $cnt++;
                }
            }
            elsif($FORM{'chk_content'} eq "on") { 
	        if($value[6] =~ /$FORM{'keyword'}/i) {
                      &printRecord;
                      $cnt++;                      
                }
            }            
       }
       if($cnt < 1) {      	   
           print "<center><font color=red><b>[$FORM{'keyword'}] ˻Ǿ ڷᰡ ϴ.</b></font></center>\n";         
       }
       print "</td></tr><tr><td align=left>&nbsp;Searched Datum : <font color=red>$cnt</font></td></tr>\n";        
       print "</td></tr></table>\n";        
    }
    
    print "<br><br><center><a href=bdr_board.cgi?db=$FORM{'db'}&action=r&p=$FORM{'p'}><img src=\"$gIMG_Board/back.gif\" border=0 alt='Back'></a></center>\n";
    
    &html_foot;  
}

##########################################################################
# ˻  
##########################################################################
sub printRecord {
    require "./lib/bd_get_file_type.cgi";

    local($actual_number);
        
        $actual_number = ($gNoOfData+1)-$i;
        
         if($actual_number > 0) {
             $date_length = length($date);
             $short_date = substr($value[5],0,20);
                          
             print "<table border=0 cellpadding=0 cellspacing=0 width=100%>\n";
             print "<tr onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
             print "<td nowrap align=center valign=middle width=30><font color=$gTableTextColor>$actual_number</font></td>\n"; #ȣ
              
             $blank = "";
             if($data_fn[0] eq '1') {
               $blank = "&nbsp;&nbsp;";
             }
             elsif($data_fn[0] eq '2') {
               $blank = "&nbsp;&nbsp;&nbsp;&nbsp;";
             }
             elsif($data_fn[0] eq '3') {
               $blank = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
             }
             elsif($data_fn[0] eq '4') {
               $blank = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
             }                          

             # ޸  
             $cnt_memo = 0;
             if(-e "$gBaseDIR/data/$value[1].txt") {
                open(HANDLE, "<$gBaseDIR/data/$value[1].txt");
                  @MEMO_DATA = <HANDLE>;
                close(HANDLE);              	
                foreach(@MEMO_DATA) {
                  $cnt_memo++;
                }
             }
              
             if($value[5] eq $date) {                                         #   
             	$temp_img = "new.gif";
             }

             print "<td nowrap align=left valign=middle style='width:100%;word-break:break-all;'>&nbsp;$blank";
                             
             if(($gFileUpload eq "checked") || ($gFileLink eq "checked")) {      # ڷ
               if($value[12] ne "") {                          
                  $Filetype = &get_file_type($value[12]);
               }
               elsif(($value[12] eq "") && ($value[3] ne "")) {
                  $Filetype = &get_file_type($value[3]);
               }
               else {
                  $Filetype = &get_file_type($value[3]);
               }
               print "<img src=\"$gIMG_FileType/$Filetype\" border=0 height=16>&nbsp;";
               
               if($gUsePreview eq "checked") {  # ̸ 
             	  $tmp_content = substr($value[6],0,$gPreviewLength);            	  
                  $tmp_content =~ s/</&lt;/g;             	
                  $tmp_content =~ s/>/&gt;/g;
                  $tmp_content =~ s/&lt;br&gt;/<br>/g;
                  $tmp_content =~ s/&lt;p&gt;/<p>/g;                  
                  $tmp_content =~ s/"/&quot;/g;
                  $tmp_content =~ s/\'/&quot;/g;
                  $tmp_content =~ s/-//g;
                  $tmp_content =~ s/\|/&#124;/g;                
                  $tmp_content =~ s/\r\n\r\n/<p>/g;
                  $tmp_content =~ s/\r\n/<br>/g;
                
                  print "<div id=my_preview$actual_number class=hide_preview><table bgcolor=$gPreviewBgcolor border=0 cellpadding=0 cellspacing=0 width=$gPreviewWidth><tr><td class=cont><font color=$gPreviewTextcolor>$tmp_content...</font></td></tr></table></div>\n";
                  print "<span id=OverDiv$actual_number style=\"visibility:visible;cursor:hand\" onMouseOut=\"hide_content('my_preview$actual_number');\">\n";
                  print " <a href=\"bdr_board.cgi?db=$FORM{'db'}&action=show_content&n=$i&p=$gCurPage&keyword=$FORM{'keyword'}&chk_name=$FORM{'chk_name'}&chk_subject=$FORM{'chk_subject'}&chk_content=$FORM{'chk_content'}\" onMouseMove=\"show_content('my_preview$actual_number', '', event, 'cmt');\"><font color=$gTableTextColor>$value[9]</font></a> \n"; # 
                  print "</span>\n";
               }
               else {
               	  print "<a href=\"bdr_board.cgi?db=$FORM{'db'}&action=show_content&n=$i&p=$gCurPage&keyword=$FORM{'keyword'}&chk_name=$FORM{'chk_name'}&chk_subject=$FORM{'chk_subject'}&chk_content=$FORM{'chk_content'}\"><font color=$gTableTextColor>$value[9]</font></a> "; # 
               }
             }
             else { #Խ
               if($gUsePreview eq "checked") {  # ̸ 
             	  $tmp_content = substr($value[6],0,$gPreviewLength);
                  $tmp_content =~ s/</&lt;/g;             	
                  $tmp_content =~ s/>/&gt;/g;
                  $tmp_content =~ s/&lt;br&gt;/<br>/g;
                  $tmp_content =~ s/&lt;p&gt;/<p>/g;
                  $tmp_content =~ s/"/&quot;/g;
                  $tmp_content =~ s/\'/&quot;/g;
                  $tmp_content =~ s/-//g;
                  $tmp_content =~ s/\|/&#124;/g;                
                  $tmp_content =~ s/\r\n\r\n/<p>/g;
                  $tmp_content =~ s/\r\n/<br>/g;
                
                  print "<div id=my_preview$actual_number class=hide_preview><table bgcolor=$gPreviewBgcolor border=0 cellpadding=0 cellspacing=0 width=$gPreviewWidth><tr><td class=cont><font color=$gPreviewTextcolor>$tmp_content...</font></td></tr></table></div>\n";
                  print "<span id=OverDiv$actual_number style=\"visibility:visible;cursor:hand\" onMouseOut=\"hide_content('my_preview$actual_number');\">\n";
                  print " <img src=\"$gIMG_Board/old.gif\" border=0>&nbsp;<a href=\"bdr_board.cgi?db=$FORM{'db'}&action=show_content&n=$i&p=$gCurPage&keyword=$FORM{'keyword'}&chk_name=$FORM{'chk_name'}&chk_subject=$FORM{'chk_subject'}&chk_content=$FORM{'chk_content'}\" onMouseMove=\"show_content('my_preview$actual_number', '', event, 'cmt');\"><font color=$gTableTextColor>$value[9]</font></a> \n"; # 
                  print "</span>\n";
               }
               else {
               	  print "<img src=\"$gIMG_Board/old.gif\" border=0>&nbsp;<a href=\"bdr_board.cgi?db=$FORM{'db'}&action=show_content&n=$i&p=$gCurPage&keyword=$FORM{'keyword'}&chk_name=$FORM{'chk_name'}&chk_subject=$FORM{'chk_subject'}&chk_content=$FORM{'chk_content'}\"><font color=$gTableTextColor>$value[9]</font></a> "; # 
               }
             }
                          
             print "<img src=\"$gIMG_Board/new.gif\" border=0>" if($value[5] eq $date); #   

             if($cnt_memo >= 1) {
                print "&nbsp;&nbsp;<font color=$gTableTextColor>[$cnt_memo]</font>";
             }
             print "</td>\n";
             
             # ̸   
             print "<td nowrap align=right valign=middle width=90><font color=$gTableTextColor>$value[2]</font> ";
             if($value[4] ne "") {
             	if($COOKIE{'MEMBER_NAME'}) {    # ȸα Ǿ ȸ  
                   print "<a href=\"javascript:NewWin('200','200','300','309','MailWin','bdr_mail.cgi?fromname=$COOKIE{'MEMBER_NAME'}&frommail=$COOKIE{'MEMBER_EMAIL'}&tomail=$value[4]')\">";   # ̸
                }
                else {
                   print "<a href=\"javascript:NewWin('200','200','300','309','MailWin','bdr_mail.cgi?tomail=$value[4]')\">";   # ̸
                }
                print "<img src=$gIMG_Board/mail.gif border=0 alt=\"$value[4]\"></a>";
             }
             else {
             	print "<img src=$gIMG_Board/mail_no.gif border=0 alt=\"   ʾҽϴ.\">";
             }
             if($value[8] ne "") {    # Ȩ 
                print "<a href=$value[8] target=\"_blank\"><img src=$gIMG_Board/home.gif border=0 alt=\"$value[8]\"></a>";
             }
             else {
             	print "<img src=$gIMG_Board/home_no.gif border=0 alt=\"Ȩ   ʾҽϴ.\">";
             }                          
             print "&nbsp;</td>\n"; 
                
             print "<td nowrap align=center valign=middle width=90><font color=$gTableTextColor>$value[5]</font></td>\n"; # 
             
              # ٿ
             if(($gFileUpload eq "checked") || ($gFileLink eq "checked")) {
             	if(($data_fn[10] eq "") && ($value[3] eq "")){          # v1.0 ȣȯ
             	   $data_fn[10] = 0;
             	   $value[10] = 0;
                }
                print "<td nowrap align=right valign=middle width=40>";
                if($data_fn[10] >= $gMinmumHit) {
                   $temp_color = "red"
                }
                else {
                   $temp_color = $gTableTextColor
                }
                print "<font color=$temp_color>$data_fn[10]</font>&nbsp;</td>\n";
             }

             # ȸ
             print "<td nowrap align=right valign=middle width=40>";
             if($data_fn[11] >= $gMinmumHit) {
             	$temp_color = "red"
             }
             else {
             	$temp_color = "$gTableTextColor"
             }
             print "<font color=$temp_color>$data_fn[11]</font>&nbsp;</td></tr>\n";
             
             
             if(($gFileUpload eq "checked") || ($gFileLink eq "checked")) {
                print "<tr><td colspan=6 width=100% height=3 background=\"$gIMG_Board/dot.gif\"></td></tr>\n";
             }
             else {
                print "<tr><td colspan=5 width=100% height=3 background=\"$gIMG_Board/dot.gif\"></td></tr>\n";             	
             }
             print "</table>\n";
      }
}

##########################################################################
# 亯 Ϻ
##########################################################################
sub ReplyMail {   
    open(MAIL, "|$gSENDMAIL -t $FORM{'receiver'}");
    print MAIL "To: $FORM{'receiver'}\n";
    print MAIL "From: $FORM{'name'}<$FORM{'email'}>\n";
    print MAIL "Subject: \"$gSupervisor_Homepage\"  亯Դϴ.\n";
    print MAIL "Content-Type: text/html\n\n";
    print MAIL "
	<html>
	<head>
	<title>A Replied Message From Board Of $gSupervisor_Homepage</title>
                <style type=text/css>
                    <!--
                    body,table,tr,td,select,input,div,form,textarea {font-family:,,verdana; font-size:9pt; color:black; line-height:12pt}
                    A:link {text-decoration:none; color:#000066;}
                    A:visited {text-decoration:none}
                    A:hover {  text-decoration:none; color:#ffee33;}
                    p,br,body,td,input,form,textarea,option {font-size:9pt;}
                    -->
                </style>
                </head>\n";
                
    $content = $FORM{'content'};
    $content =~ s/<br>/\n/g;
    $content =~ s/<p>/\n\n/g;                
    
     print MAIL "<body bgcolor=ffffff oncontextmenu='return true'>
           	      <table border=1 cellPadding=3 cellSpacing=1 width=98% bordercolorlight=#000000 bordercolordark=#ffffff align=center>
         	       <tr>
         	        <td align=right colspan=2><a href=$gSupervisor_Homepage target=_blank>$gSupervisor_Homepage</a></td>
         	       </tr>
         	       <tr>
         	        <td align=center valign=top width=10%>
         	          
         	        </td>         	       
         	        <td align=left width=88%>
         	         $FORM{'subject'}
         	        </td>
         	       </tr>         	                	       
         	       <tr>
         	        <td align=center valign=top width=10%>
         	          
         	        </td>         	                	       
         	        <td align=left width=88%>
         	        <pre>$content
         	        </pre>
         	        </td>
         	       </tr>
    	        </table></div>\n";
	print MAIL "</body></html>\n";
	close (MAIL);
}

##########################################################################
#  α δ
##########################################################################
sub show_user_ogin {
    require "./lib/cm_html_head.cgi";
    
    local($command);

    if($FORM{'c'} eq "delete") {
        $command = "delete";
    }
    else {
        $command = "show_update_form";
    }
       
    &html_head("bdr_board");
    print "<TABLE WIDTH=220 valign=top align=center border=0 background=$gIMG_Board/m_bg.gif>\n";    
    print "<tr><td align=center valign=top>\n";    
    print "<form method=post name=userlogin action=bdr_board.cgi>\n";
    print "<input type=hidden name=db value=$FORM{'db'}>\n"; 
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=action value=$command>\n";
    print "<input type=hidden name=l value=$FORM{'l'}>\n";
    print "<center><br><b> </b><br><br><center>\n" if($command eq "delete");
    print "<center><br><b> </b><br><br><center>\n" if($command eq "show_update_form");
    print "<font color=$gTextColor>йȣ </font>\n";
    print "<input type=password name=passwd size=12 maxlength=16> \n";
    print "</td></tr>\n";
    print "<tr><td align=right valign=top>\n";
    print "<input type=submit value=\" Ȯ  \">\n";
    print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    print "</form>\n";
    print "<br><br><br><br></td></tr></table>\n";
    print "<script language=\"javascript\">document.userlogin.passwd.focus();</script>\n";    
    &html_foot;       
}

##########################################################################
# ϵ ȭ Ѵ
##########################################################################
sub delete_data {
    require "./lib/cm_lock.cgi";
    require "./lib/cm_get_num_info.cgi";    
    require "./lib/cm_put_num_info.cgi";
    
    local($attach_filename,$attach_img_filename);
    local(@datum,@value);
    
    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);

    &lock("$FORM{'db'}_data");
    open(HANDLE,">$gBaseDIR/$gDatFile");    
    foreach $data (@datum) {
        @value = split(/\|/, $data);
        if($FORM{'l'} != $value[1]) {
            print HANDLE "$data";             
        }
        else {
            $attach_filename = $value[12];
            $attach_img_filename = $value[13];
        }
    }
    close(HANDLE);
    &unlock("$FORM{'db'}_data");
    
    if($attach_filename) {
       unlink ("$gUploadDIR/$attach_filename");
    }
    if($attach_img_filename) {
       unlink ("$gUploadDIR/$attach_img_filename");
    }
    
    unlink("$gBaseDIR/data/$FORM{'l'}.cgi");
    if(-e "$gBaseDIR/data/$FORM{'l'}.txt") {
       unlink("$gBaseDIR/data/$FORM{'l'}.txt");
    }
    
    &get_num_info;    
    $gNoOfData--;    
    &put_num_info($gNoOfData);

    print "Content-type: text/html\n\n";
    print "<html>\n";
    print "<meta http-equiv=refresh content=0;url=bdr_board.cgi?db=$FORM{'db'}&action=r&p=$FORM{'p'}>\n";
    print "</html>\n";
}

##########################################################################
# ϵ  ȭ Ѵ
##########################################################################
sub delete_notice_data {
    require "./lib/cm_get_num_info.cgi";
    require "./lib/cm_lock.cgi";
    
    local(@datum,@value);
    
    open(HANDLE,"$gBaseDIR/$gNtcFile");
        @datum = <HANDLE>;
    close(HANDLE);
    
    &lock("$FORM{'db'}_data");
    open(HANDLE,">$gBaseDIR/$gNtcFile");    
    foreach $data (@datum) {
        @value = split(/\|/, $data);
        if($FORM{'l'} != $value[1]) {
            print HANDLE "$data";             
        }
    }
    close(HANDLE);
    &unlock("$FORM{'db'}_data");
        
    unlink("$gBaseDIR/data/$FORM{'l'}.cgi");

    &get_num_info;

    print "Content-type: text/html\n\n";
    print "<html>\n";
    print "<meta http-equiv=refresh content=\"0;url=bdr_board.cgi?db=$FORM{'db'}&action=r&p=$FORM{'p'}\"></head>\n";
    print "</html>\n";
}

##########################################################################
# ϵ ȭ  Ʈ 
##########################################################################
sub show_update_form {   	
    require "./lib/cm_html_head.cgi";
	
    local($data,$name,$value,$subject_len);
    local(@cookies);
    
    require "./lib/cm_get_cookie.cgi";    
    &get_cookie;
 
    open(HANDLE,"$gBaseDIR/data/$FORM{'l'}.cgi");
        $data = <HANDLE>;
    close(HANDLE);
    @value = split(/\|/,$data);             

    if(!-e "./members/logon/$COOKIE{'MEMBER_ID'}.cgi") {
       $gIsMember = false;	
    }
    else {
       $gIsMember = true;	
    }
        
    &html_head("bdr_board");  

    print "<br><table border=1 width=450 bgcolor=#eeeeee bordercolorlight=#cccccc bordercolordark=#ffffff cellspacing=0 cellpadding=5 align=center>\n";    
    print "<tr><td align=center>\n";    
    print "<form method=post name=inputForm action=bdr_board.cgi>\n";
    print "<input type=hidden name=db value=$FORM{'db'}>\n"; 
    print "<input type=hidden name=action value=update>\n";
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=l value=$FORM{'l'}>\n";
    print "<input type=hidden name=OldPassword value=$value[0]>\n";
    print "<input type=hidden name=passwd value=$value[0]>\n";

    print "<table border=0 cellspacing=1 cellpadding=2>\n";    
    print "<tr><td align=right><span class=cls><b>Name</b></span></td><td>\n";
    $value[2] =~ s/<br>/\n/g;
                  
    if($gIsMember eq "true") {
       print "<input type=text size=53 maxlength=4 name=name value=$value[2] class=text readonly></td></tr>\n";
       print "<tr><td align=right><span class=cls><b>E-Mail</b></span></td><td>\n";
       print "<input type=text size=53  maxlength=30 name=email class=text value=\"$value[4]\" readonly></td></tr>\n";
       print "<tr><td align=right><span class=cls><b>Homepage</b></span></td><td>\n";
       print "<input name=homepage type=text size=53 maxlength=53 value=\"$value[8]\" class=text readonly></td></tr>\n";
    }
    else {
       print "<input name=name size=53 maxlength=4 value=\"$value[2]\" type=text class=text maxlength=12></td></tr>\n";
       print "<tr><td align=right><span class=cls><b>E-Mail</b></span></td><td>\n";
       print "<input name=email size=53 maxlength=30 value=\"$value[4]\" type=text class=text maxlength=25></td></tr>\n";
       print "<tr><td align=right><span class=cls><b>Homepage</b></span></td><td>\n";
       print "<input name=homepage type=text size=53 maxlength=53 value=\"$value[8]\" type=text class=text maxlength=53></td></tr>\n";  
    }

    if($gShowEmoticon eq "checked") {
    	  $subject_len = 35;
    }
    else {
    	  $subject_len = 45;
    }   
    print "<tr><td align=right><span class=cls><b>Subject</b></span></td><td>\n";
    print "<input type=text name=subject value=\"$value[9]\" size=$subject_len maxlength=45 class=text> <input type=checkbox name=html value=checked style=\"background-color:#eeeeee;border:0\">html\n";
    
    if($gShowEmoticon eq "checked") {
       print "<a href=javascript:NewWin('200','200','240','280','EmoticonWin','bdr_board.cgi?db=$FORM{'db'}&action=insert_emoticon')><img src=$gIMG_Emoticon/emoticon.gif border=0 alt=\"̸Ƽ\"></a></td></tr>\n";
    }               
    $value[6] =~ s/<br>/\n/g;
    $value[6] =~ s/<p>/\n\n/g;
    print "<tr><td align=right valign=top><span class=cls><b>Content</b></span></td><td><textarea name=content rows=15 cols=52 class=comment>$value[6]</textarea></td>\n";    
    print "</tr>\n";      

    if($gFileLink eq "checked") {      # ϸũ
       print "<tr><td align=right><span class=cls><b>File Link</b></span></td><td><input type=text name=filelink value=\"$value[3]\" class=text size=53>\n";
    }
    else {
       print "<input type=hidden name=filelink value=\"$value[3]\">\n";
    }
    print "   </td></tr>\n";
    if($gFileImgLink eq "checked") {   # ̹ũ
       print "<tr><td align=right><span class=cls><b>Image Link</b></span></td><td><input type=text name=fileimglink value=\"$value[14]\" class=text size=53>\n";
    }
    else {
       print "<input type=hidden name=fileimglink value=\"$value[14]\">\n";
    }
    print "   </td></tr>\n";    
    if($gFileUpload eq "checked") {    # Ͼε
       print "<tr><td align=right><span class=cls><b>File Upload</b></span></td><td><input type=text name=update_fileupload value=\"$value[12]\" class=text size=53 readonly>\n";
    }
    else {
       print "<input type=hidden name=fileupload value=\"$value[12]\">\n";
    }
    if($gFileImgUpload eq "checked") { # ̹ε    
       print "<tr><td align=right><span class=cls><b>Screen Shot</b></span></td><td><input type=text name=update_fileimgupload value=\"$value[13]\" class=text size=53 readonly>\n";
    }
    else {
       print "<input type=hidden name=fileimgupload value=\"$value[13]\">\n";
    }       
    print "   </td></tr>\n";
    print "<tr><td align=center colspan=2><input type=submit value=\" Ȯ  \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"> <input type=reset value=\" Է \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"></td>\n";
    print "</tr></table>\n";
    print "</td></tr></table>\n";
    print "</form>\n";
    print "<script language=\"javascript\">document.inputForm.content.focus();</script>\n";
       
    &html_foot;       
}

##########################################################################
# ϵ  ȭ  Ʈ 
##########################################################################
sub show_notice_update_form {
    require "./lib/cm_html_head.cgi";	
    
    local($data,$name,$value,$subject_len);
    local(@cookies);
    
    require "./lib/cm_get_cookie.cgi";
    &get_cookie;
 
    open(HANDLE,"$gBaseDIR/data/$FORM{'l'}.cgi");
        $data = <HANDLE>;
    close(HANDLE);
    @value = split(/\|/,$data);             

    &html_head("bdr_board");  
    print "<br><table border=1 width=450 bgcolor=#eeeeee bordercolorlight=#cccccc bordercolordark=#ffffff cellspacing=0 cellpadding=5 align=center>\n";
    print "<tr><td align=center>\n";    
    print "<form method=post name=inputForm action=bdr_board.cgi>\n";
    print "<input type=hidden name=db value=$FORM{'db'}>\n"; 
    print "<input type=hidden name=action value=update_notice>\n";
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=l value=$FORM{'l'}>\n";       
    print "<input type=hidden name=name value=$value[2]>\n";
    print "<input type=hidden name=mode value=notice>\n";       

    if($gShowEmoticon eq "checked") {
    	  $subject_len = 35;
    }
    else {
    	  $subject_len = 45;
    }
       
    print "<table border=0 cellspacing=1 cellpadding=2>\n";    
    print "<tr><td align=right><span class=cls><b>Subject</b></span></td><td>\n";    
    print "<input type=text name=subject value=\"$value[9]\" size=$subject_len maxlength=40 class=text> <input type=checkbox name=html value=checked style=\"background-color:#eeeeee;border:0\">html\n";
    if($gShowEmoticon eq "checked") {
       print "<a href=javascript:NewWin('200','200','240','280','EmoticonWin','bdr_board.cgi?db=$FORM{'db'}&action=insert_emoticon')><img src=$gIMG_Emoticon/emoticon.gif border=0 alt=\"̸Ƽ\"></a></td></tr>\n";
    }       
    $value[6] =~ s/<br>/\n/g;
    $value[6] =~ s/<p>/\n\n/g;
    print "<tr><td align=right valign=top><span class=cls><b>Content</b></span></td><td><textarea name=content rows=15 cols=52 class=comment>$value[6]</textarea></td>\n";    
    print "</tr>\n";      
    print "<tr><td align=center colspan=2><input type=submit value=\" Ȯ  \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"> <input type=reset value=\" Է \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"></td>\n";
    print "</tr></table>\n";
    print "</td></tr></table>\n";
    print "</form>\n";
    print "<script language=\"javascript\">document.inputForm.content.focus();</script>\n";
    &html_foot;       
}



##########################################################################
#  ȭ Ѵ
##########################################################################
sub makeNewFile { 
    require "./lib/cm_lock.cgi";
    require "./lib/cm_get_date.cgi";
	
    local(@set);

    &get_date;
    
    @set = ('0'..'9');
    srand(time);
    $gRandomFilename = "$d$set[rand(10)]$set[rand(10)]$set[rand(10)]$set[rand(10)]$set[rand(10)]$set[rand(10)]";
    
    &lock("$FORM{'db'}_newfile");
    open(HANDLE,">$gBaseDIR/data/$gRandomFilename.cgi");
        print HANDLE "$gCryptPassword|$gRandomFilename|$name|$filelink|$email|$date|$content|$ip|$homepage|$subject|0|0|$fname|$finame|$fileimglink|||||||\n";
    close(HANDLE);
    &unlock("$FORM{'db'}_newfile");
}

##########################################################################
# ε ȭ ߰Ѵ
##########################################################################
sub appendIndexFile {
    local($data);
    local(@datum,@point);
    
    require "./lib/cm_lock.cgi";
    
    &lock("$FORM{'db'}_data");
    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);
    
    if($FORM{'l'}) {    #  
        open(HANDLE,">$gBaseDIR/$gDatFile");
        foreach $data (@datum) {
            @point = split(/\|/,$data);
            if($point[1] eq $FORM{'l'}) {
                $thread = $point[0] + 1;        # ù° 0,  ޶ 1 
                  print HANDLE "$data";
	  print HANDLE "$thread|$gRandomFilename|||||||||0|0|$fname|$finame||||||||\n";
            }
            else {
                  print HANDLE "$data";
            }
        }
        close(HANDLE);
     }
     else {
        open(HANDLE,">$gBaseDIR/$gDatFile");
        foreach $data (@datum) {
            if($data =~ /<!--EOF-->/) {
                print HANDLE "<!--EOF-->\n";
	print HANDLE "0|$gRandomFilename|||||||||0|0|$fname|$finame||||||||\n";
            }
            else {
                print HANDLE "$data";
            }
        }
        close(HANDLE);
    }
    &unlock("$FORM{'db'}_data");
}

##########################################################################
# ε  ȭ ߰Ѵ
##########################################################################
sub appendNoticeIndexFile {
    local($data);
    local(@datum,@point);
    
    require "./lib/cm_lock.cgi";
    
    &lock("$FORM{'db'}_ntc");
    if(-e "$gBaseDIR/$gNtcFile") {
        open(HANDLE,"<$gBaseDIR/$gNtcFile");
          @datum = <HANDLE>;
        close(HANDLE);
        
        open(HANDLE,">$gBaseDIR/$gNtcFile");
        foreach $data(@datum) {
            if($data =~ /<!--EOF-->/) {
              print HANDLE "<!--EOF-->\n";            	
              print HANDLE "0|$gRandomFilename|\n";
            }
            else {
              print HANDLE "$data";            	
            }
        }
        close(HANDLE);
    }
    else { 
        open(HANDLE,">$gBaseDIR/$gNtcFile");
        print HANDLE "<!--EOF-->\n";            	
        print HANDLE "0|$gRandomFilename|\n";
        close(HANDLE);    	
    }
    &unlock("$FORM{'db'}_ntc");
}

##########################################################################
# ٿεϱ
##########################################################################
sub download_data {
       if(-e "$gBaseDIR/data/$FORM{'l'}.cgi") {
         &addHitDownCounter;
         
         if(($FORM{'file'}=~ /http:\/\/.+/) || ($FORM{'file'}=~ /ftp:\/\/.+/)) {
            print "Location:$FORM{'file'}\n\n";
         }
         else {
            print "Location:$gUploadURL/$FORM{'file'}\n\n";
         }	
         exit;
      }	
}

##########################################################################
# ȸ
##########################################################################
sub add_hit_counter {   	
    local($data,$temp);
    local(@datum,@value,@t);             

    require "./lib/cm_lock.cgi";
    require "./lib/cm_get_cookie.cgi";    
    &get_cookie;
    
    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);

    &lock("$FORM{'db'}_data");
    open(HANDLE,">$gBaseDIR/$gDatFile");   
    for($i=0;$i<=$gNoOfData;$i++) {
        @value = split(/\|/,$datum[$i]);             
        if ($i eq $FORM{'n'}) {                           # $FORM{'n'} ̸ ȸ 
            $filen = "$value[1].cgi";
            $value[11] = $value[11] + 1;
            print HANDLE "$value[0]|$value[1]|||||||||$value[10]|$value[11]|$value[12]|$value[13]||||||||\n";
        }
        else {
            print HANDLE $datum[$i];
        }
    }
    close(HANDLE);
    &unlock("$FORM{'db'}_data");

    open(HANDLE,"<$gBaseDIR/data/$filen");
        $temp = <HANDLE>;
    close(HANDLE);
    @t = split(/\|/, $temp);
        
    $t[11] = $t[11] + 1;
    &lock("$FORM{'db'}_hitcount");    
    open(HANDLE,">$gBaseDIR/data/$filen");
            print HANDLE "$t[0]|$t[1]|$t[2]|$t[3]|$t[4]|$t[5]|$t[6]|$t[7]|$t[8]|$t[9]|$t[10]|$t[11]|$t[12]|$t[13]|$t[14]|$t[15]|$t[16]|$t[17]|$t[18]|$t[19]|$t[20]|\n";
    close(HANDLE);    
    &unlock("$FORM{'db'}_hitcount");
}

##########################################################################
# ٿ
##########################################################################
sub addHitDownCounter {    	
    require "./lib/cm_lock.cgi";    
    require "./lib/cm_get_cookie.cgi";    
    
    local($data,$temp);
    local(@datum,@value,@t);

    &get_cookie;

    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);

    &lock("$FORM{'db'}_data");
    open(HANDLE,">$gBaseDIR/$gDatFile");   
    for($i=0;$i<=$gNoOfData;$i++) {
        @value = split(/\|/,$datum[$i]);             
        if ($i eq $FORM{'d'}) {                           # $FORM{'n'} ̸ ٿ 
            $filen = "$value[1].cgi";
            $value[10] = $value[10] + 1;            
            print HANDLE "$value[0]|$value[1]|||||||||$value[10]|$value[11]|$value[12]|$value[13]||||||||\n";
        }
        else {
            print HANDLE $datum[$i];
        }
    }
    close(HANDLE);
    &unlock("$FORM{'db'}_data");
    
    open(HANDLE,"<$gBaseDIR/data/$filen");
        $temp = <HANDLE>;
    close(HANDLE);
    @t = split(/\|/, $temp);
        
    $t[10] = $t[10] + 1;
    &lock("$FORM{'db'}_downcount");        
    open(HANDLE,">$gBaseDIR/data/$filen");
            print HANDLE "$t[0]|$t[1]|$t[2]|$t[3]|$t[4]|$t[5]|$t[6]|$t[7]|$t[8]|$t[9]|$t[10]|$t[11]|$t[12]|$t[13]|$t[14]|$t[15]|$t[16]|$t[17]|$t[18]|$t[19]|$t[20]|\n";
    close(HANDLE);    
    &unlock("$FORM{'db'}_downcount");    
}
 
##########################################################################
# Ʈ  ϵ ȭ ã Ѵ.
##########################################################################
sub update_data {
    require "./lib/cm_lock.cgi";
    	
    local(@datum,@value);
    
    &getVariable;
   
    open(HANDLE,"<$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);

    &lock("$FORM{'db'}_data");
    open(HANDLE,">$gBaseDIR/$gDatFile");
    foreach $data (@datum) {
        @value = split(/\|/,$data);
        if($FORM{'l'} eq $value[1]) {
#                                         0     |ϸ      |||||||||ٿ|ȸ|ε|ε̹||||||
            print HANDLE "$value[0]|$FORM{'l'}|||||||||$value[10]|$value[11]|$fname|$finame||||||||\n";
        }
        else {
            print HANDLE "$data";
        }
    }
    close(HANDLE);
    &unlock("$FORM{'db'}_data");    
    
    &lock("$FORM{'db'}_data2");
    open(HANDLE,">$gBaseDIR/data/$FORM{'l'}.cgi");
#                         ȣ            |ȭϸ    |̸ |ϸũ|̸|¥ |    |ip |Ȩ |    |ٿ|ȸ|ε|ε̹|̹ϸũ|||||||
    print HANDLE "$FORM{'OldPassword'}|$FORM{'l'}|$name|$filelink|$email|$date|$content|$ip|$homepage|$subject|$value[10]|$value[11]|$fname|$finame|$fileimglink|||||||\n";
    close(HANDLE);
    &unlock("$FORM{'db'}_data2");
    
    print "Content-type: text/html\n\n";
    print "<html>\n";
    print "<meta http-equiv=refresh content=0;url=bdr_board.cgi?db=$FORM{'db'}&action=r&p=$FORM{'p'}>\n";
    print "</html>\n";
}

##########################################################################
# Ʈ  ϵ  ȭ ã Ѵ.
##########################################################################
sub update_notice_data {
    require "./lib/cm_lock.cgi";
    	
    local(@datum,@value);
   
    &getVariable;
   
    open(HANDLE,"<$gBaseDIR/$gNtcFile");
        @datum = <HANDLE>;
    close(HANDLE);

    &lock("$FORM{'db'}_data");
    open(HANDLE,">$gBaseDIR/$gNtcFile");
    foreach $data (@datum) {
        @value = split(/\|/,$data);
        if($FORM{'l'} eq $value[1]) {
#                                         0     |ϸ      |||||||||ٿ|ȸ|ε|ε̹|||||||||
            print HANDLE "$value[0]|$FORM{'l'}|||||||||$value[10]|$value[11]|$value[12]|$value[13]||||||||\n";
        }
        else {
            print HANDLE "$data";
        }
    }
    close(HANDLE);
    &unlock("$FORM{'db'}_data");    
    
    &lock("$FORM{'db'}_data2");
    open(HANDLE,">$gBaseDIR/data/$FORM{'l'}.cgi");
#                         ȣ            |ȭϸ    |̸ |ϸũ|̸|¥ |    |ip |Ȩ |    |ٿ|ȸ|ε|ε̹|̹ϸũ|||||||
        print HANDLE "$FORM{'OldPassword'}|$FORM{'l'}|$name|$filelink|$email|$date|$content|$ip|$homepage|$subject|$value[10]|$value[11]|$fname|$finame|$fileimglink|||||||\n";
    close(HANDLE);
    &unlock("$FORM{'db'}_data2");
    
    print "Content-type: text/html\n\n";
    print "<html>\n";
    print "<meta http-equiv=refresh content=0;url=bdr_board.cgi?db=$FORM{'db'}&action=r&p=$FORM{'p'}>\n";
    print "</html>\n";
}

##########################################################################
#  α
##########################################################################
sub show_admin_login {
    require "./lib/cm_html_head.cgi";	
    
    local($command);
    
    &html_head("bdr_board");
    unless(open(HANDLE,"$gBaseDIR/$gPwdFile")) {        #Խǻ   
        print "<table width=220 valign=top align=center border=0 background=$gIMG_Board/m_bg.gif>\n";
        print "<tr><td align=center valign=top>\n";        	
        print "<br><form action=bdr_board.cgi name=passwdconfig>\n";
        print "<input type=hidden name=db value=$FORM{'db'}>\n";    
        print "<input type=hidden name=action value=$FORM{'c'}>\n";
        print "<input type=hidden name=p value=$FORM{'p'}>\n";
        print "<input type=hidden name=l value=$FORM{'l'}>\n";        
        print "<input type=hidden name=ps value=new>\n";
        print "<b> йȣ </b><br><br>\n";
        print "<table border=0 width=150>\n";
        print "<tr><td width=60 align=left>йȣ</td><td align=left><input type=password name=newpasswd size=12 maxlength=16></td></tr>\n";
        print "<tr><td width=60 align=left>  </td><td align=left><input type=password name=repasswd size=12 maxlength=16></td></tr>\n";
        print "<tr><td width=60></td><td align=left><input type=submit value=\" Ȯ \"></td></tr>\n";
        print "</table>\n";
        print "</font></form>\n";
        print "<br></td></tr></table>\n";            
        print "<script language=\"javascript\">document.passwdconfig.newpasswd.focus();</script>\n";                        
    }
    else {
        print "<table width=220 valign=top align=center border=0 background=$gIMG_Board/m_bg.gif>\n";
        print "<tr><td align=center valign=top>\n";        	    	
        print "<br><form method=post action=bdr_board.cgi name=config>\n";
        print "<input type=hidden name=db value=$FORM{'db'}>\n"; 
        print "<input type=hidden name=action value=$FORM{'c'}>\n";        
        print "<input type=hidden name=p value=$FORM{'p'}>\n";
        print "<input type=hidden name=l value=$FORM{'l'}>\n";                
        print "<input type=hidden name=ps value=old>\n";
        print "<b> </b><br>\n";
        print "<br>йȣ&nbsp;<input type=password name=oldpasswd size=12 maxlength=16>\n";
        print "</td></tr>\n";
        print "<tr><td align=right valign=top>\n";                    
        print " <input type=submit value=\" Ȯ \">\n";
        print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";            
        print "</form>\n";
        print "<br><br><br><br></td></tr></table>\n";                    
        print "<script language=\"javascript\">document.config.oldpasswd.focus();</script>\n";
    }
    &html_foot;
    close(HANDLE);
}

##########################################################################
# ڿ  ȯ漳
##########################################################################
sub show_config_form {
    require "./lib/cm_html_head.cgi";	
    
    &html_head("bdr_board");
    print "<br><table border=1 width=500 bgcolor=#eeeeee bordercolorlight=#cccccc bordercolordark=#ffffff cellspacing=1 cellpadding=0 align=$gAlignType><tr><td bgcolor=#ffffff>\n";
    print "<br><b><center><font color=\"3355cc\">Configuration For <b>$gSupervisor_HomeName</b></font></center><br><br>\n";
    print "<table border=0 width=100% align=center cellspacing=3 cellpadding=3><tr><td>\n";
    print "<form action=bdr_board.cgi>\n";
    print "<input type=hidden name=db value=$FORM{'db'}>\n";
    print "<input type=hidden name=action value=config>\n";
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=ps value=new>\n";

# DB 
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> :: DB :: </b></td></tr>\n";
    print "<tr><td align=left>CGI Ÿ</td><td align=right><input type=hidden name=CgiType value=board><font color=#777777><b>    </b></font></td></tr>\n";
    print "<tr><td align=left>ȸ ٱ</td>\n";
    print "<td align=right>
    <select name=UserType>\n";
    if($gUserType eq "type_normal") {
        print "<option value=type_normal selected>&nbsp;&nbsp;";
        print "<option value=type_only_read>Ϻ⸸";        
        print "<option value=type_member>ٺҰ&nbsp;&nbsp;";
    }
    elsif($gUserType eq "type_only_read") {
        print "<option value=type_normal>&nbsp;&nbsp;";
        print "<option value=type_only_read selected>Ϻ⸸";                
        print "<option value=type_member>ٺҰ&nbsp;&nbsp;";
    }
    elsif($gUserType eq "type_member") {
        print "<option value=type_normal>&nbsp;&nbsp;";
        print "<option value=type_only_read>Ϻ⸸";                
        print "<option value=type_member selected>ٺҰ&nbsp;&nbsp;";
    }    
    print "</select></td></tr>\n";
    print "<tr><td colspan=2 align=right><input type=checkbox name=AdminOnly value=checked $gAdminOnly style=\"background-color:#ffffff;border:0\">ڸ</td></tr>\n";
    print "</table><br>\n";

# йȣ     
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> :: йȣ  :: </b></td></tr>\n";
    print "<tr align=right><td align=left>йȣ</td><td align=right><input type=password name=newpasswd size=12 maxlength=16></td></tr>\n";
    print "<tr align=right><td align=left>Է</td><td align=right><input type=password name=repasswd size=12 maxlength=16>\n";
    print "</td></tr></table><br>\n";

### ###
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> ::   :: </b></td></tr>\n";
    
    print "<tr><td align=left></td>\n";
    print "<td align=right>";
    if($gTitleUse eq "YES") {         #  ȣȯ ؼ 
       $gTitleUse = "checked";
    }
    print "<input type=checkbox name=TitleUse value=checked $gTitleUse style=\"background-color:#ffffff;border:0\">̱\n";
    print "</td></tr>\n";    
    
    print "<tr><td align=left>ڻ</td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gTextColor\">&nbsp;&nbsp;</td></tr></table><input type=text name=TextColor value=\"$gTextColor\" size=9></td></tr>\n";
    print "<tr><td align=left></td><td align=right><table border=1  bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gBackColor\">&nbsp;&nbsp;</td></tr></table><input type=text name=BackColor value=\"$gBackColor\" size=9></td></tr>\n";    
    print "<tr><td align=left> ̹ URL</td><td align=right><input type=text name=BackImgURL value=\"$gBackImgURL\" size=50></td></tr>\n";
    print "</table><br>\n";

### ###
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> ::   :: </b></td></tr>\n";

    print "<tr><td align=left> </td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gTableTitleBgColor\">&nbsp;&nbsp;</td></tr></table><input type=text name=TableTitleBgColor value=\"$gTableTitleBgColor\" size=9></td></tr>\n";
    print "<tr><td align=left> ڻ</td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gTableTitleTextColor\">&nbsp;&nbsp;</td></tr></table><input type=text name=TableTitleTextColor value=\"$gTableTitleTextColor\" size=9></td></tr>\n";    
    print "<tr><td align=left> </td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gTableBgColor\">&nbsp;&nbsp;</td></tr></table><input type=text name=TableBgColor value=\"$gTableBgColor\" size=9></td></tr>\n";
    print "<tr><td align=left> ڻ</td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gTableTextColor\">&nbsp;&nbsp;</td></tr></table><input type=text name=TableTextColor value=\"$gTableTextColor\" size=9></td></tr>\n";    
    print "<tr><td align=left>콺 ġ Խù </td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gActiveTableColor\">&nbsp;&nbsp;</td></tr></table><input type=text name=ActiveTableColor value=\"$gActiveTableColor\" size=9></td></tr>\n";
    print "</table><br>\n";

###Display ###
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> :: Display  :: </b></td></tr>\n";
    print "<tr><td align=left></td><td align=right><INPUT TYPE=BUTTON value=' ::  :: ' onclick=javascript:NewWin('200','200','450','340','NoticeWin','bdr_board.cgi?db=$FORM{'db'}&action=admin_login&c=show_notice_form')></td></tr>\n";    
    print "<tr><td align=left>Ĺ</td><td align=right><select name=AlignType>\n";
    if($gAlignType eq "left") {
        print "<option value=left selected>Left";
        print "<option value=center>Center";
        print "<option value=right>Right&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }    
    elsif($gAlignType eq "center" || $gAlignType eq "") {
        print "<option value=left>Left";
        print "<option value=center selected>Center";
        print "<option value=right>Right&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }
    elsif($gAlignType eq "right") {
        print "<option value=left>Left";
        print "<option value=center>Center";
        print "<option value=right selected>Right&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }    
    print "</select></td></tr>\n";
    
    print "<tr><td align=left>̺ ũ</td><td align=right><input type=text name=TableWidth value=\"$gTableWidth\" size=12 maxlength=4></td></tr>\n";
    print "<tr><td align=left>  ȸ&ٿ</td><td align=right><input type=text name=MinmumHit value=\"$gMinmumHit\" size=12 maxlength=3></td></tr>\n";    
    print "<tr><td align=left>ȭ  ̵</td><td align=right><input type=text name=ListNumber value=\"$gListNumber\" size=12 maxlength=2></td></tr>\n";
    print "<tr><td align=left>ȭ Խù ϼ</td><td align=right><input type=text name=RecPerPage value=\"$gRecPerPage\" size=12 maxlength=2></td></tr>\n";    
    print "<tr><td align=left>ȸ ϴܿ Խù ̱</td>\n";
    print "<td align=right>";
    if($gFList eq "show") {         #  ȣȯ ؼ 
       $gFList = "checked";
    }
    print "<input type=checkbox name=FList value=checked $gFList style=\"background-color:#ffffff;border:0\">̱\n";    
    print "</td></tr>\n";            

    print "<tr><td align=left>޸</td>\n";
    print "<td align=right>";
    if($gWriteMemo eq "show") {     #  ȣȯ ؼ 
       $gWriteMemo = "checked";
    }
    print "<input type=checkbox name=WriteMemo value=checked $gWriteMemo style=\"background-color:#ffffff;border:0\">̱\n";        
    print "</td></tr>\n";            
    
    print "<tr><td align=left≯Ƽ</td>\n";
    print "<td align=right>";
    if($gShowEmoticon eq "show") {
       $gShowEmoticon = "checked";  #  ȣȯ ؼ
    }
    print "<input type=checkbox name=ShowEmoticon value=checked $gShowEmoticon style=\"background-color:#ffffff;border:0\">̱\n";        
    print "</td></tr>\n";            

    print "<tr><td align=left>IP</td>\n";
    print "<td align=right>";
    print "<input type=checkbox name=ShowIPInfo value=checked $gShowIPInfo style=\"background-color:#ffffff;border:0\">̱\n";    
    print "</td></tr>\n";                

    print "<tr><td align=left>̹&÷ Link</td>\n";
    print "<td align=right>";
    if($gFileImgLink eq "show") {
       $gFileImgLink = "checked";    	
    }    
    print "<input type=checkbox name=FileImgLink value=checked $gFileImgLink style=\"background-color:#ffffff;border:0\">̱\n";    
    print "</td></tr>\n";   
    print "</table><br>\n";
        
###̸ ###
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> :: ̸  :: </b></td></tr>\n";
    print "<tr><td align=left≯</td>\n";
    print "<td align=right><input type=checkbox name=UsePreview value=checked $gUsePreview style=\"background-color:#ffffff;border:0\">Ȱȭ\n";
    print "</td></tr>\n";                
    print "<tr><td align=left≯ </td><td align=right><input type=text name=PreviewWidth value=\"$gPreviewWidth\" size=12 maxlength=3></td></tr>\n";    
    print "<tr><td align=left≯ </td><td align=right><input type=text name=PreviewLength value=\"$gPreviewLength\" size=12 maxlength=3></td></tr>\n";
    print "<tr><td align=left≯ </td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gPreviewBgcolor\">&nbsp;&nbsp;</td></tr></table><input type=text name=PreviewBgcolor value=\"$gPreviewBgcolor\" size=9 maxlength=7></td></tr>\n";    
    print "<tr><td align=left≯ ڻ</td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gPreviewTextcolor\">&nbsp;&nbsp;</td></tr></table><input type=text name=PreviewTextcolor value=\"$gPreviewTextcolor\" size=9 maxlength=7></td></tr>\n";    
    print "</td></tr>\n";         
    print "</table><br>\n";
   
###ڷ ###
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> :: ڷ  :: </b></td></tr>\n";    

    print "<tr><td align=left> Link</td>\n";
    print "<td align=right>";
    if($gFileLink eq "show"){        #  ȣȯ ؼ
       $gFileLink = "checked";
    }    
    print "<input type=checkbox name=FileLink value=checked $gFileLink style=\"background-color:#ffffff;border:0\">̱\n";    
    print "</td></tr>\n";     
            
    print "<tr><td align=left> ε</td>\n";
    print "<td align=right>";
    if($gFileUpload eq "show") {     #  ȣȯ ؼ
       $gFileUpload = "checked";
    }    
    print "<input type=checkbox name=FileUpload value=checked $gFileUpload style=\"background-color:#ffffff;border:0\">̱\n";
    print "</td></tr>\n";                   

    print "<tr><td align=left>ũ ε</td>\n";
    print "<td align=right>";
    if($gFileImgUpload eq "show") {  #  ȣȯ ؼ
       $gFileImgUpload = "checked";
    }    
    print "<input type=checkbox name=FileImgUpload value=checked $gFileImgUpload style=\"background-color:#ffffff;border:0\">̱\n";    
    print "</td></tr>\n";
    
    print "<tr><td align=left>εϿ뷮</td><td align=right><font color=999999>( : MB)</font> <input type=text name=MaxFileSize value=\"$gMaxFileSize\" size=12 maxlength=8></td></tr>\n";
    print "</table><br>\n";    
    
    print "</td></tr></table>\n";
    print "</td></tr></table><br>\n";
    
    print "<center><input type=submit value=\" Ȯ  \"></center>\n";
    print "</form>\n";

    &html_foot;
}

##########################################################################
# ȯ漳 ƮѴ
##########################################################################
sub update_config_variables {
    require "./lib/cm_check_password.cgi";
    
    &check_admin_password if($FORM{'newpasswd'} || $FORM{'repassword'});

    $gCgiType = $FORM{'CgiType'};
    $gUserType = $FORM{'UserType'};
    $gAdminOnly = $FORM{'AdminOnly'};    
    $gBackColor = $FORM{'BackColor'};
    $gTextColor = $FORM{'TextColor'};
    $gBackImgURL = $FORM{'BackImgURL'};
    $gTableTextColor = $FORM{'TableTextColor'};
    $gTableWidth = $FORM{'TableWidth'};         
    $gRecPerPage = $FORM{'RecPerPage'} if($FORM{'RecPerPage'} >= 1);
    $gListNumber = $FORM{'ListNumber'};
    $gActiveTableColor = $FORM{'ActiveTableColor'};
    $gTitleUse = $FORM{'TitleUse'};
    $gTableBgColor = $FORM{'TableBgColor'};
    $gAlignType = $FORM{'AlignType'};
    $gFList = $FORM{'FList'};
    $gFileLink = $FORM{'FileLink'};  
    $gFileImgLink = $FORM{'FileImgLink'};    
    $gFileUpload = $FORM{'FileUpload'};
    $gFileImgUpload = $FORM{'FileImgUpload'};              
    $gMaxFileSize = $FORM{'MaxFileSize'};
    $gTableTitleBgColor = $FORM{'TableTitleBgColor'};
    $gTableTitleTextColor = $FORM{'TableTitleTextColor'};
    $gMinmumHit = $FORM{'MinmumHit'};
    $gWriteMemo = $FORM{'WriteMemo'};    
    $gShowEmoticon = $FORM{'ShowEmoticon'};    
    $gUsePreview = $FORM{'UsePreview'};
    $gPreviewLength = $FORM{'PreviewLength'};        
    $gPreviewWidth = $FORM{'PreviewWidth'};
    $gPreviewBgcolor = $FORM{'PreviewBgcolor'};
    $gPreviewTextcolor = $FORM{'PreviewTextcolor'};   
    $gShowIPInfo = $FORM{'ShowIPInfo'};

    $gMyTemp01 = $FORM{'MyTemp01'};
    $gMyTemp02 = $FORM{'MyTemp02'};
    $gMyTemp03 = $FORM{'MyTemp03'};
    $gMyTemp04 = $FORM{'MyTemp04'};
    $gMyTemp05 = $FORM{'MyTemp05'};
    $gMyTemp06 = $FORM{'MyTemp06'};
    $gMyTemp07 = $FORM{'MyTemp07'};
    $gMyTemp08 = $FORM{'MyTemp08'};
    $gMyTemp09 = $FORM{'MyTemp09'};
    $gMyTemp10 = $FORM{'MyTemp10'};
    $gMyTemp11 = $FORM{'MyTemp11'};
         
    $gTempColor8 = $FORM{'TempColor8'};
    $gTempColor5 = $FORM{'TempColor5'};
    $gTempColor6 = $FORM{'TempColor6'};    
    $gTempYesOrNo1 = $FORM{'TagUse'};    
    $gTempYesOrNo2 = $FORM{'TempYesOrNo2'};
    
    &put_config_variables;
    $gCurPage = $FORM{'p'};   

    print "Content-type: text/html\n\n";
    print "<html>\n";
    print "<meta http-equiv=refresh content=\"0;url=bdr_board.cgi?db=$FORM{'db'}&action=r&p=$FORM{'p'}\">\n";
    print "</html>\n";
}

#value0  = ȣ
#value1  = ȭϸ
#value2  = ̸
#value3  = ũ
#value4  = ̸
#value5  = ¥
#value6  = 
#value7  = IP
#value8  = Ȩ
#value9  = 
#value10 = ٿ
#value11 = ȸ
#value12 = ε ϸ
#value13 = ε ̹ ϸ
#value14 = ũ̹
#value15 = 
#value16 = 
#value17 = 
#value18 = 
#value19 = 
#value20 = 
